'
'    Module TREK.BAS
'
'    This version written by Burns Lab, University of Florida
'    Physics Department
'
'    Trek is an enhanced and expanded recreationn from memory of it's function, of Super Star Trek written around
'    1975 in Fortran, I believe by David Matuszek & Paul Reynolds with modifications by Don Smith.
'
'    Three modules must be compiled together in QuickBasic 4.5
'
'    TREK.BAS
'    TREKMOD1.BAS
'    TREKMOD2.BAS
'
'    Start Date: 1988 by Michael Burns
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <https://www.gnu.org/licenses/>.
'
'
'    BETA TEST VERSION 3.0  LAST UPDATE 5-JAN-91
'
'    Copyrigth 1991 by Michael Burns, US copyright registration number TX946379
'
DECLARE SUB PROLOG ()
DECLARE SUB TRANSPORT ()
DECLARE SUB SSCAN ()
DECLARE SUB ABANDON ()
DECLARE SUB CHNGCLOAK ()
DECLARE SUB COMMANDS ()
DECLARE SUB COMSCREEN ()
DECLARE SUB DELAY (X!)
DECLARE SUB DOCK ()
DECLARE SUB ENDGAME ()
DECLARE SUB GALDRAW ()
DECLARE SUB HELP ()
DECLARE SUB INITSECT ()
DECLARE SUB KATTACKS ()
DECLARE SUB LRSCAN ()
DECLARE SUB MAKEDISPLAY ()
DECLARE SUB MOVE ()
DECLARE SUB NOVA ()
DECLARE SUB PHASOR ()
DECLARE SUB PTORPEDOES ()
DECLARE SUB REPAIRS ()
DECLARE SUB REPAIRSTATUS ()
DECLARE SUB SECDRAW ()
DECLARE SUB SENERGY ()
DECLARE SUB SETWARP ()
DECLARE SUB SHIELD ()
DECLARE SUB SWAIT ()
DECLARE SUB SRANGESCAN ()
DECLARE SUB WORKSHEET ()
DECLARE SUB TIMEWARP ()
        DIM GAL$(9, 9), HGAL$(9, 9), OGAL$(9, 9), CGAL(9, 9)' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA, OGAL IS THE ORIGINAL
        DIM SEC$(10, 10), SUPI(3), SUPJ(3), BEZI(5), BEZJ(5), BEZA(5)
        DIM PLANI(10), PLANJ(10), PLANC(10), COMI(20), COMJ(20), ROMI(20), ROMJ(20)
        DIM STRENGTH(9, 9), DLEN(8), BSI(5), BSJ(5)
        COMMON SHARED /GALAXY/ GAL$(), HGAL$(), OGAL$(), CGAL(), LEVEL' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA
        COMMON SHARED /SECTOR1/ SEC$(), SUPI(), SUPJ(), BEZI(), BEZJ(), BEZA()
        COMMON SHARED /SECTOR2/ PLANI(), PLANJ(), PLANC(), COMI(), COMJ(), ROMI(), ROMJ()
        COMMON SHARED /SECTOR3/ STRENGTH(), DLEN(), PLANETS, TDOWN, HEREWEARE
        COMMON SHARED /SHIP1/ drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        COMMON SHARED /SHIP2/ SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, ODATE, life
        COMMON SHARED /SHIP3/ TRANSPORTER, SX, SY, SHIP$, CLOAK, computer, EX, EY
        COMMON SHARED /BASEINFO/ BASES, HELPCOUNT
        COMMON SHARED /ENEMIES1/ BERZERKS, Klingons, commanders, SUPERS, ENEMY, KLINGS
        COMMON SHARED /ENEMIES2/ EATEN, ECLOAK, BFLAG, ROMULANS, oromulans
        COMMON SHARED /ENDGAMEINFO1/ OKLINGONS, OCOMMANDERS, OSUPERS, OROLULANS, ENDOFGAME
        COMMON SHARED /ENDGAMEINFO2/ KBERZERKERS, BASEDESTROYED, PLANETSLOST, IDATE
        COMMON SHARED /STRINGS/ C$, BACKGROUND
        COMMON SHARED /colors/ BLUE, RED, GREEN, FRED, FBLUE, BLACK, PURPLE, ORANGE
        COMMON SHARED /PLAYERS/ DOCTOR$, ENGINEER$, WOFFICER$, COFFICER$, SOFFICER$, NAVIGATOR$, MENEMIES$, benemies$
VBEGIN: CLEAR
        VIEW PRINT 1 TO 25
        RANDOMIZE TIMER:
        SCREEN 0: CLS : WIDTH 80, 25
        COLOR 7, 0: CLS
        PRINT "Program TREK  V3.0 -- University of Florida, Physics"
        PRINT "Written by BurnsLab (Where Science gets the business!)      FAX: (904) 392-0524"
        PRINT "Original Version: 12-APR-83"
        PRINT "Last Update : 5-JAN-91          CGA-EGA-VGA COLOR, MDA B&W VERSION"
        PRINT "Uses math chip automatically if present."
        PRINT : PRINT
        PRINT "Feel free to distribute copies of this program in unmodified form."
        PRINT "There are no warrenties, implied or otherwise, that this program"
        PRINT "will execute properly on any specific brand of machine. "
        PRINT
        PRINT "NOTE TO THOSE WHO HATE INSTRUCTIONS: The command syntax of this"
        PRINT "version is close to the VAX versions of a decade ago. Except this"
        PRINT "version is VERY intelligent and much more complicated."
        PRINT
        COLOR 12, 0: PRINT "Type ? <cr> during game for command list, hit F1 for help screen."
        PRINT
        PRINT
        COLOR 7, 0
INITIALIZE: PRINT "Are you a beginner, intermediate or emeritus player (B, I, or E, <cr>=I) "; : INPUT A$
        A$ = UCASE$(A$)
        IF A$ = "" THEN A$ = "I"
        IF A$ <> "B" AND A$ <> "I" AND A$ <> "E" THEN GOTO INITIALIZE
        PRINT "Is this a color monitor (Y or N, <cr>=Y) "; : INPUT B$
        B$ = UCASE$(B$)
        IF LEFT$(B$, 1) = "N" THEN
                BACKGROUND = 0
                BLUE = 15
                RED = 15
                GREEN = 15
                FRED = 15 + 16
                FBLUE = 15 + 16
                BLACK = 7
                PURPLE = 15
                ORANGE = 15
        ELSE
                BACKGROUND = 7
                BLUE = 1
                RED = 4
                GREEN = 2
                FRED = 20
                FBLUE = 17
                BLACK = 0
                PURPLE = 5
                ORANGE = 6
        END IF
        DOCTOR$ = "McKoy"
        ENGINEER$ = "Scotty"
        WOFFICER$ = "Chekov"
        COFFICER$ = "Uhura"
        SOFFICER$ = "Spock"
        NAVIGATOR$ = "Sulu"
        MENEMIES$ = "Klingon"
        benemies$ = "Doomsday Machine"
        PRINT "Is this Classic Trek "
        PRINT "      or Next Generation Trek (C or N, <cr>= computer chooses) "; : INPUT B$
        B$ = UCASE$(B$)
        IF B$ = "" THEN
                IF RND > .5 THEN B$ = "C" ELSE B$ = "N"
        END IF
        IF LEFT$(B$, 1) = "N" THEN
                DOCTOR$ = "Dr. Crusher"
                ENGINEER$ = "Jory"
                WOFFICER$ = "Warf"
                COFFICER$ = "Warf"
                SOFFICER$ = "Data"
                NAVIGATOR$ = "Ensign Crusher"
                MENEMIES$ = "Ferengi"
                benemies$ = "Borg"
        END IF
        PRINT "Creating Galaxy. This may take a few seconds ..."
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        HGAL$(I, J) = ""
                NEXT J
        NEXT I
        IF A$ = "E" THEN
                LEVEL = 3
                Klingons = INT(30 * RND) + 85
                ROMULANS = INT(20 * RND)
                commanders = INT(20 * RND)
                SUPERS = INT(2 * RND) + 1
                BERZERKS = INT(5 * RND + 1)
                PLANETS = INT(10 * RND)
                BASES = INT(5 * RND) + 2
                SHIP$ = "U.S.S. ENTERPRISE"
                NOS = INT(30 * RND) + 40' NUMBER OF OCCUPIED SECTORS
        END IF
        IF A$ = "I" THEN
                LEVEL = 2
                Klingons = INT(30 * RND) + 50
                ROMULANS = INT(10 * RND)
                commanders = INT(5 * RND)
                SUPERS = 1
                BERZERKS = INT(3 * RND)
                PLANETS = INT(5 * RND)
                BASES = INT(3 * RND) + 2
                SHIP$ = "U.S.S. ENTERPRISE"
                NOS = INT(30 * RND) + 10' NUMBER OF OCCUPIED SECTORS
        END IF
        IF A$ = "B" THEN
                LEVEL = 1
                Klingons = INT(10 * RND) + 10
                ROMULANS = 0
                commanders = INT(2 * RND)
                SUPERS = 0
                BERZERKS = 0
                PLANETS = 2
                BASES = INT(3 * RND) + 2
                SHIP$ = "U.S.S. ENTERPRISE"
                NOS = INT(5 * RND) + 10' NUMBER OF OCCUPIED SECTORS
        END IF
        EATEN = 0
        BASEDESTROYED = 0
        PLANETSLOST = 0
        OKLINGONS = Klingons
        OSUPERS = SUPERS
        oromulans = ROMULANS
        OCOMMANDERS = commanders
        OBERZERKERS = BERZERKS
GALAXY: KLINGONI = Klingons
        FOR I = 1 TO 9
        FOR J = 1 TO 9
NQUAD:  ID = CINT(1 + RND * 8): JD = CINT(1 + RND * 8)
        IF ID < 1 OR ID > 9 OR JD < 1 OR JD > 9 THEN GOTO NQUAD
        IF HGAL$(ID, JD) <> "" THEN GOTO NQUAD
        S$ = LTRIM$(STR$(INT(7 * RND)))
        IF RND < .1 THEN S$ = "0"
        K = INT(7 * RND + 2)
        IF 1! - RND < .1 THEN K = 0
        IF K > KLINGONI THEN K = KLINGONI
        KLINGONI = KLINGONI - K
        KLINGI = KLINGI + K
        K$ = LTRIM$(STR$(K))
        HGAL$(ID, JD) = K$ + "0" + S$
        HGAL$(ID, JD) = LTRIM$(HGAL$(ID, JD))
        HGAL$(ID, JD) = RTRIM$(HGAL$(ID, JD))
        GAL$(ID, JD) = "---"
        OGAL$(ID, JD) = HGAL$(ID, JD)
        NEXT J, I
        IF commanders = 0 THEN GOTO SUPER
        FOR I = 1 TO commanders
        COMI(I) = INT(8 * RND) + 1
        COMJ(I) = INT(8 * RND) + 1
        NEXT I
SUPER:  IF SUPERS = 0 THEN GOTO BERZERK
        FOR I = 1 TO SUPERS
        SUPI(I) = INT(8 * RND) + 1
        SUPJ(I) = INT(8 * RND) + 1
        NEXT I
BERZERK: IF BERZERKS = 0 THEN GOTO PLANET
        FOR I = 1 TO BERZERKS
        BEZI(I) = INT(8 * RND) + 1
        BEZJ(I) = INT(8 * RND) + 1
        IF PLANETS < 10 THEN PLANETS = PLANETS + 1
        PLANI(I) = BEZI(I)
        PLANJ(I) = BEZJ(I)
        PLANC(I) = 0
        IF RND > .2 THEN PLANC(I) = 2 + INT(RND * 2)
        BEZA(I) = 0
        NEXT I
PLANET: IF PLANETS = 0 THEN GOTO BASEL
        FOR I = BERZERKS + 1 TO PLANETS
        PLANI(I) = INT(8 * RND) + 1
        PLANJ(I) = INT(8 * RND) + 1
        PLANC(I) = 0
        IF RND > .7 THEN PLANC(I) = 1 + INT(RND * 1)
        NEXT I
BASEL:   IF BASES = 0 THEN GOTO SHIP
        FOR I = 1 TO BASES
BASEAG: BASI = INT(8 * RND) + 1
        BASJ = INT(8 * RND) + 1
        IF INSTR(GAL$(BASI, BASJ), "B") <> 0 THEN GOTO BASEAG
        GAL$(BASI, BASJ) = "-B-"
        K$ = "": S$ = ""
        K$ = LEFT$(HGAL$(BASI, BASJ), 1)
        S$ = RIGHT$(HGAL$(BASI, BASJ), 1)
        HGAL$(BASI, BASJ) = K$ + "B" + S$
        OGAL$(BASI, BASJ) = HGAL$(BASI, BASJ)
        NEXT I
        SX = INT(8 * RND) + 1: SY = INT(8 * RND) + 1
SHIP:   drive = 2
        HELPCOUNT = 0
        KLINGS = 0
        CONDITION = 1
        ENERGY = 20000
        SHIELDS = 1
        CLOAK = 1
        SHENERGY = 10000
        SPEED = 7
        TDOWN = 0
        HEREWEARE = 0
        computer = 1
        CRYSTALS = 1
        PHASORS = 1
        TORPEDOES = 20
        SPERCENT = 100
        life = 1
        SDATE = INT(200 * RND) + 5000
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        CGAL(I, J) = SDATE
                NEXT J
        NEXT I
        IDATE = SDATE
        TRANSPORTER = 1
        GAL$(SX, SY) = RIGHT$(HGAL$(SX, SY), 3)
        EX = INT(8 * RND) + 1: EY = INT(8 * RND) + 1
        CALL INITSECT
        CALL PROLOG
        SCREEN 0: COLOR BLUE, BACKGROUND, 7: CLS
        LOCATE 21, 1
        CALL MAKEDISPLAY
        ON KEY(1) GOSUB COMDISPLAY
        KEY(1) ON
        IF LEVEL = 1 THEN ON TIMER(20) GOSUB ATTACKS
        IF LEVEL = 2 THEN ON TIMER(10) GOSUB ATTACKS
        IF LEVEL = 3 THEN ON TIMER(5) GOSUB ATTACKS
        TIMER ON
        ON ERROR GOTO ERRMESSAGE
GETCOM: COLOR BLUE, BACKGROUND: TIMER ON
        X = FRE(0)
        IF Klingons < 1 THEN CALL ENDGAME
        X = FRE("")
        COLOR RED, BACKGROUND
        X = POS(0)
        Y = CSRLIN
        LOCATE 25, 1
        PRINT "Press ? <Enter> for command list, Press F1 for help";
        LOCATE Y, X
        COLOR BLUE, BACKGROUND
        PRINT "Command ? ";
WCOM:   A$ = INKEY$: IF A$ = "" THEN GOTO WCOM
        IF A$ = CHR$(14) THEN CLS : GOTO GETCOM
        COLOR BLACK, BACKGROUND
        PRINT A$;
        LINE INPUT ""; C$
        C$ = A$ + C$
        CLS
        IF MENEMIES$ <> "Klingon" THEN
                IF RND > .5 THEN
                        COFFICER$ = "Riker"
                        WOFFICER$ = "Riker"
                ELSE
                        COFFICER$ = "Warf"
                        WOFFICER$ = "Warf"
                END IF
        END IF
        ENDOFGAME = 0
        ODATE = SDATE
        CGAL(SX, SY) = SDATE
        C$ = UCASE$(C$)
        C$ = LTRIM$(C$): C$ = RTRIM$(C$)
        IF C$ = "ABANDON" THEN CALL ABANDON: GOTO GETCOM
        IF LEFT$(C$, 2) = "CL" THEN CALL CHNGCLOAK: CALL KATTACKS: GOTO UNIVRESPONSE
        IF C$ = "D" OR C$ = "DOCK" THEN CALL DOCK: GOTO UNIVRESPONSE
        IF C$ = "?" THEN CALL COMMANDS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 4) = "HELP" THEN CALL HELP: GOTO UNIVRESPONSE
        IF C$ = "L" OR C$ = "LONG" THEN CALL LRSCAN: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "M " THEN CALL MOVE: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "T " THEN CALL PTORPEDOES: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "TR" THEN CALL TRANSPORT: GOTO UNIVRESPONSE
        IF LEFT$(C$, 1) = "P" THEN CALL PHASOR: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "SE" THEN CALL SENERGY: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "SH" THEN CALL SHIELD: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "WA" THEN CALL SWAIT: CALL REPAIRS: CALL KATTACKS: GOTO GETCOM
        IF LEFT$(C$, 1) = "W" THEN CALL SETWARP: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "RS" THEN CALL REPAIRSTATUS
        IF LEFT$(C$, 1) = "F" THEN CALL WORKSHEET
        IF C$ = "S" THEN
                CALL SSCAN
                VIEW PRINT 1 TO 24
                CLS
                CALL MAKEDISPLAY
        END IF
        IF C$ = "QUIT" THEN CALL ENDGAME
UNIVRESPONSE: IF ENDOFGAME = 1 THEN
                VIEW PRINT 1 TO 24
                CLS
                GOTO VBEGIN
        END IF
        CALL REPAIRS
        GOTO GETCOM
ERRMESSAGE: COLOR RED, BACKGROUND: PRINT "Say what, Captain ?": COLOR BLUE, BACKGROUND
        PRINT : PRINT
        RESUME GETCOM
COMDISPLAY: CALL COMSCREEN
        CLS
        COLOR RED, BACKGROUND
        X = POS(0)
        Y = CSRLIN
        LOCATE 25, 1
        PRINT "Press ? <Enter> for command list, Press F1 for help    ";
        LOCATE Y, X
        COLOR BLUE, BACKGROUND
        PRINT "Command ? ";
        RETURN
ATTACKS: TIMER OFF
        cursorcol = POS(0): cursorrow = CSRLIN
        BFLAG = 0
        KATT = KATT + 1
        FOR XXB = 1 TO BERZERKS
                IF BEZA(XXB) = 1 THEN BFLAG = BFLAG + 1
        NEXT XXB
        BFLG = BFLAG
        FOR BBI = 1 TO 9
                FOR BBJ = 1 TO 9
                        IF SEC$(BBI, BBJ) = CHR$(21) AND BFLAG > 0 THEN
                                BSI(BFLG) = BBI: BSJ(BFLG) = BBJ
                                BFLG = BFLG - 1
                        END IF
                NEXT BBJ
        NEXT BBI
        EGAME = 0
        FOR XXB = 1 TO BFLAG
                INDEX = -1: IF BSI(XXB) < EX THEN INDEX = 1
                INDEY = -1: IF BSJ(XXB) < EY THEN INDEY = 1
                IF BSI(XXB) = EX THEN INDEX = 0
                IF BSI(XXB) = EY THEN INDEY = 0
                OX = BSI(XXB): OY = BSJ(XXB)
                BSI(XXB) = BSI(XXB) + INDEX
                BSJ(XXB) = BSJ(XXB) + INDEY
                IF BSI(XXB) < 1 THEN BSI(XXB) = 1
                IF BSI(XXB) > 9 THEN BSI(XXB) = 9
                IF BSJ(XXB) < 1 THEN BSJ(XXB) = 1
                IF BSJ(XXB) > 9 THEN BSJ(XXB) = 9
                SEC$(OX, OY) = "."
                IF SEC$(BSI(XXB), BSJ(XXB)) = "E" THEN EATEN = 1: CALL ENDGAME
                IF SEC$(BSI(XXB), BSJ(XXB)) = "Q" THEN EATEN = 1: CALL ENDGAME
                IF SEC$(BSI(XXB), BSJ(XXB)) = "S" OR SEC$(BSI(XXB), BSJ(XXB)) = "C" OR SEC$(BSI(XXB), BSJ(XXB)) = "K" THEN
                        Klingons = Klingons - 1: KLINGS = KLINGS - 1
                        ENEMY = ENEMY - 1
                        STRENGTH(BSI(XXB), BSJ(XXB)) = 0
                END IF
                IF SEC$(BSI(XXB), BSJ(XXB)) = "S" THEN
                        SUPERS = SUPERS - 1
                        FOR SI = 1 TO 3
                                IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                        NEXT SI
                END IF
                IF SEC$(BSI(XXB), BSJ(XXB)) = "C" THEN
                        commanders = commanders - 1
                        FOR SI = 1 TO 20
                                IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                        NEXT SI
                END IF
                IF SEC$(BSI(XXB), BSJ(XXB)) = " " THEN
                        KBERZERKERS = KBERZERKERS + 1
                        FOR XXBB = 1 TO BERZERKS
                                IF BEZA(XXBB) = 1 THEN
                                        BEZA(XXBB) = 0
                                        GOTO OUTBERZERKS
                                END IF
                        NEXT XXBB
OUTBERZERKS:            SEC$(BSI(XXB), BSJ(XXB)) = " "
                        COLOR RED, BACKGROUND
                        PRINT SOFFICER$; " reports, '"; benemies$; " just fell down a Black Hole, Captain.'"
                        COLOR BLUE, BACKGROUND
                        GOTO STARTKS
                END IF
                SEC$(BSI(XXB), BSJ(XXB)) = CHR$(21)
        NEXT XXB
STARTKS: IF KATT = 2 + INT(RND * 2) THEN KATT = 0: CALL KATTACKS
        FOR IIJ = 1 TO 3
                IF SUPI(IIJ) = SX AND SUPJ(IIJ) = SY THEN GOTO EATTACKS
        NEXT IIJ
        IF LEVEL > 1 AND ENERGY < 3000 AND CONDITION >= 0 THEN
                FOR IIJ = 1 TO 3
                        IF SUPI(IIJ) <> 0 AND SUPJ(IIJ) <> 0 THEN
                                PRINT SHIP$; " pulled to quadrant "; SUPI(IIJ); ","; SUPJ(IIJ); " by long range tractor beam."
                                SX = SUPI(IIJ): SY = SUPJ(IIJ)
                                PRINT "Command ?";
                                cursorcol = POS(0): cursorrow = CSRLIN
                                CALL INITSECT
                                CALL MAKEDISPLAY
                                FOR JJI = 1 TO 4000: NEXT JJI
                                GOTO EATTACKS
                        END IF
                NEXT IIJ
        END IF
        IF RND * LEVEL > 1 AND SHIELDS < 0 AND CONDITION >= 0 THEN
                FOR IIJ = 1 TO 3
                        IF SUPI(IIJ) <> 0 AND SUPJ(IIJ) <> 0 THEN
                                PRINT SHIP$; " pulled to quadrant "; SUPI(IIJ); ","; SUPJ(IIJ); " by long range tractor beam."
                                SX = SUPI(IIJ): SY = SUPJ(IIJ)
                                PRINT "Command ?";
                                cursorcol = POS(0): cursorrow = CSRLIN
                                CALL INITSECT
                                CALL MAKEDISPLAY
                                FOR JJI = 1 TO 4000: NEXT JJI
                                GOTO EATTACKS
                        END IF
                NEXT IIJ
        END IF
        CALL SECDRAW
EATTACKS: RDUMMY = RND
        IF RDUMMY < .48 OR RDUMMY > .5 OR LEVEL = 1 THEN
                LOCATE cursorrow, cursorcol
                RETURN
        END IF
        IF BASES = 0 THEN
                LOCATE cursorrow, cursorcol
                RETURN
        END IF
BASEINSERT: FOR KI = 1 TO 9
        FOR KJ = 1 TO 9
        X = 0
        X = INSTR(GAL$(KI, KJ), "B")
        IF KI = SX AND KJ = SY THEN X = 0
        IF SUPERS <= 0 THEN X = 0
        IF X <> 0 THEN
                BASES = BASES - 1
                HGAL$(KI, KJ) = LTRIM$(HGAL$(KI, KJ))
                HGAL$(KI, KJ) = RTRIM$(HGAL$(KI, KJ))
                KK$ = LEFT$(HGAL$(KI, KJ), 1)
                KS$ = RIGHT$(HGAL$(KI, KJ), 1)
                HGAL$(KI, KJ) = ""
                HGAL$(KI, KJ) = KK$ + "0" + KS$
                GAL$(KI, KJ) = HGAL$(KI, KJ)
                CGAL(KI, KJ) = NDATE
                GOTO DBASE
        END IF
        NEXT KJ
        NEXT KI
        COLOR RED, BACKGROUND
        X = POS(0)
        Y = CSRLIN
        LOCATE 25, 1
        PRINT "Press ? <Enter> for command list, Press F1 for help    ";
        LOCATE Y, X
        COLOR BLUE, BACKGROUND
        PRINT "Command ? ";
        TIMER ON
        RETURN
DBASE:  CALL MAKEDISPLAY
        COLOR RED, BACKGROUND
        PRINT COFFICER$; " reports, 'StarFeet reports StarBase "; INT(1 + RND * 20); "in quadrant "; KI; ","; KJ; " is DESTROYED !'"
        COLOR RED, BACKGROUND
        X = POS(0)
        Y = CSRLIN
        LOCATE 25, 1
        PRINT "Press ? <Enter> for command list, Press F1 for help    ";
        LOCATE Y, X
        COLOR BLUE, BACKGROUND
        PRINT "Command ? ";
        TIMER ON
        RETURN

SUB COMMANDS
        '
        ' Here we display the possible commands
        '
        SHARED BACKGROUND
        TEMP = BLUE
        IF BACKGROUND = 0 THEN BLUE = 7
        COLOR RED, BACKGROUND
        PRINT "Commands: RED "; : COLOR BLUE, BACKGROUND: PRINT "letters ONLY. F1 <ENTER> FOR DETAILED HELP."
        COLOR RED, BACKGROUND
        PRINT "ABANDON       ";
        COLOR RED, BACKGROUND: PRINT "CL"; : COLOR BLUE, BACKGROUND: PRINT "oak  ";
        COLOR RED, BACKGROUND: PRINT "D"; : COLOR BLUE, BACKGROUND: PRINT "ock  ";
        COLOR RED, BACKGROUND: PRINT "L"; : COLOR BLUE, BACKGROUND: PRINT "ong Range Scan      ";
        COLOR RED, BACKGROUND: PRINT "M"; : COLOR BLUE, BACKGROUND: PRINT "ove    ";
        COLOR RED, BACKGROUND: PRINT "P"; : COLOR BLUE, BACKGROUND: PRINT "hasors         "
        COLOR RED, BACKGROUND: PRINT "QUIT "; : COLOR BLUE, BACKGROUND
        COLOR RED, BACKGROUND: PRINT " RS"; : COLOR BLUE, BACKGROUND: PRINT " Repair Status  ";
        COLOR RED, BACKGROUND: PRINT "S"; : COLOR BLUE, BACKGROUND: PRINT "hort Range Scan   ";
        COLOR RED, BACKGROUND: PRINT "SE"; : COLOR BLUE, BACKGROUND: PRINT " Shield Energy     ";
        COLOR RED, BACKGROUND: PRINT "SH"; : COLOR BLUE, BACKGROUND: PRINT "ields"
        COLOR RED, BACKGROUND: PRINT "T"; : COLOR BLUE, BACKGROUND: PRINT "orpedoes    ";
        COLOR RED, BACKGROUND: PRINT "TR"; : COLOR BLUE, BACKGROUND: PRINT "ransporter ";
        COLOR RED, BACKGROUND: PRINT "W"; : COLOR BLUE, BACKGROUND: PRINT "arp  ";
        COLOR RED, BACKGROUND: PRINT "WA"; : COLOR BLUE, BACKGROUND: PRINT "it  ";
        COLOR RED, BACKGROUND: PRINT "F"; : COLOR BLUE, BACKGROUND: PRINT "lips to fake work sheet"
        BLUE = TEMP
END SUB

SUB MOVE
        '
        ' Here we move the ship
        '
        SHARED SX, SY, SHIP$, EX, EY
        SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
        SHARED KLINGS, TDOWN
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
        SHARED TRANSPORTER, C$, computer, IDATE, BACKGROUND
        DIM CORD(4)
        IF TDOWN = 1 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'Abandoning the landing party is a capital offense, Captian.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        TNSX = 0: TNSY = 0
        IF CLOAK = 1 THEN ECLOAK = 1
        IF CRYSTALS = 0 AND SPEED > 1 THEN
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " says, 'Captain, running the warp drive with bad crystals can destroy the ship."
                PRINT "Should we proceed ?'"; : COLOR BLACK, BACKGROUND: INPUT Y$
                Y$ = UCASE$(Y$)
                IF LEFT$(Y$, 1) = "Y" THEN GOTO MSTART
                EXIT SUB
        END IF
MSTART: I = LEN(C$) - 2: AUTO = 0: MAUTO = 1
        IF CRYSTALS = 0 AND RND > .9 AND SPEED > 1 THEN
                CALL TIMEWARP
                EXIT SUB
        END IF
        IF SPEED * SPEED > 60 + RND * 36 THEN
                CALL TIMEWARP
                SPEED = 1
                ENERGY = 500
                CALL MAKEDISPLAY
                PRINT SOFFICER$; " reports, 'The antimatter reactor seems to be drained.'"
                EXIT SUB
        END IF
        C$ = RIGHT$(C$, I)
        J = INSTR(C$, "M")
        IF J = 0 THEN AUTO = 1: J = INSTR(C$, "A")
        IF AUTO = 1 AND computer = 0 THEN
                CLS
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, 'We cannot navigate automatically with a damaged computer, Captain.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF J = 0 THEN COLOR RED, BACKGROUND: PRINT "Wrong syntax": COLOR BLUE, BACKGROUND: EXIT SUB
        I = LEN(C$)
        C$ = LTRIM$(RIGHT$(C$, I - J))
        I = LEN(C$)
        IF AUTO = 0 THEN GOTO MANUAL
        IF AUTO = 1 AND INSTR(C$, "-") <> 0 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " says, 'Huh ?'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF I = 3 THEN
                NSX = VAL(LEFT$(C$, 1))
                NSY = VAL(RIGHT$(C$, 1))
                NGAX = 0: NGAY = 0
                TNSX = 0: TNSY = 0
                ELSE
                NGAX = VAL(LEFT$(C$, 1))
                NGAY = VAL(MID$(C$, 3, 1))
                TNSX = VAL(MID$(C$, 5, 1))
                TNSY = VAL(RIGHT$(C$, 1))
                IX = NGAX - SX: IY = NGAY - SY
                IF IX <> 0 THEN
                        SLOPE = IY / IX
                        IF IX < 0 THEN NSX = 1 ELSE NSX = 9
MLOOP:                  NSY = SLOPE * (NSX - EX) + EY
                        IF NSY < 1 OR NSY > 9 THEN NSX = NSX - SGN(IX): GOTO MLOOP
                        GOTO MENTRY
                END IF
                IF IX = 0 THEN NSX = EX: NSY = 9 * IY
                IF NSX > 9 THEN NSX = 9
                IF NSX < 1 THEN NSX = 1
                IF NSY > 9 THEN NSY = 9
                IF NSY < 1 THEN NSY = 1
        END IF
MENTRY: GDIST = SQR((SX - NGAX) ^ 2 + (SY - NGAY) ^ 2)
        ELOSS = (SPEED ^ 3) * GDIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
        IF ELOSS > ENERGY THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " says, 'But Captain, we need a wee bit more energy to do that !'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IX = NSX - EX: IY = NSY - EY
        IF IX <> 0 THEN SLOPE = IY / IX
        INDEX = 1: IF NSX < EX THEN INDEX = -1
        INDEY = 1: IF NSY < EY THEN INDEY = -1
        TRAJECTORY = EY
        FOR J = EX TO NSX STEP INDEX
        IF J < 1 THEN GOTO ENDJ
        IF IX <> 0 THEN TRAJECTORY = CINT((SLOPE * (J - EX)) + EY)
        IF IX = 0 THEN TRAJECTORY = TRAJECTORY + INDEY
        IF TRAJECTORY < 1 OR TRAJECTORY > 9 THEN GOTO ENDJ
        IF SEC$(J, TRAJECTORY) <> "." AND SEC$(J, TRAJECTORY) <> "E" AND SEC$(J, TRAJECTORY) <> "Q" THEN GOTO COLLISION
ENDJ:   NEXT J
        IF NGAX = 0 THEN
                IF SEC$(NSX, NSY) <> "." AND SEC$(NSX, NSY) <> "E" AND SEC$(NSX, NSY) <> "Q" THEN GOTO COLLISION
                DIST = SQR((EX - NSX) ^ 2 + (EY - NSY) ^ 2) / 10
                ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
                ENERGY = ENERGY - ELOSS
                IF ENERGY < 0 THEN ENERGY = 0
                SDATE = SDATE + GDIST / (SPEED * SPEED)
                IF NSX < 1 THEN NSX = 1
                IF NSY < 1 THEN NSY = 1
                SEC$(EX, EY) = "."
                EX = NSX: EY = NSY
                IF KLINGS <> 0 THEN CONDITION = 3
                IF CONDITION < 1 THEN CONDITION = 1
                CALL MAKEDISPLAY
                EXIT SUB
        END IF
        SEC$(EX, EY) = "."
        DIST = SQR((EX - J) ^ 2 + (EY - TRAJECTORY) ^ 2) / 10
        IF TNSX = 0 THEN
                EX = NSX
                EY = NSY
                ELSE
                EX = TNSX
                EY = TNSY
        END IF
        GDIST = DIST + SQR((SX - NGAX) ^ 2 + (SY - NGAY) ^ 2)
        SX = NGAX
        SY = NGAY
        IF CONDITION < 1 THEN CONDITION = 1
        CALL INITSECT
        ELOSS = (SPEED ^ 3) * GDIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
        ENERGY = ENERGY - ELOSS
        IF ENERGY < 0 THEN ENERGY = 0
        SDATE = SDATE + GDIST / (SPEED * SPEED)
        IF KLINGS <> 0 THEN CONDITION = 3
        CALL MAKEDISPLAY
        EXIT SUB
MANUAL: AUTO = 1: MAUTO = 0
        CCOUNT = 0
        FOR PARSE = 1 TO 4
        CORD(PARSE) = 0
        C$ = LTRIM$(C$): C$ = RTRIM$(C$)
        IF C$ = "" THEN GOTO NPARSE
        I = LEN(C$)
        IF INSTR(C$, " ") <> 0 AND I <> 0 THEN
                CORD(PARSE) = VAL(LEFT$(C$, INSTR(C$, " ")))
                C$ = RIGHT$(C$, I - INSTR(C$, " "))
                CCOUNT = CCOUNT + 1
                GOTO NPARSE
        END IF
        IF INSTR(C$, " ") = 0 AND I <> 0 THEN CORD(PARSE) = VAL(C$): CCOUNT = CCOUNT + 1: C$ = ""
NPARSE: NEXT PARSE
STMAN:  BARFLAG = 0
        IF CCOUNT > 2 THEN
                BARFLAG = 1
                NGAX = CORD(1) + SX
                NGAY = CORD(2) + SY
                NSX = CORD(3) + EX
                NSY = CORD(4) + EY
                NGAX = INT((NGAX * 10 + NSX) / 10): NGAY = INT((NGAY * 10 + NSY) / 10)
                NSX = (NSX MOD 10) + 1: NSY = (NSY MOD 10) + 1
                TNSX = NSX: TNSY = NSY
        ELSE
                NSX = CORD(1) + EX
                NSY = CORD(2) + EY
                TNSX = 0: TNSY = 0
                NGAX = INT((NGAX * 10 + NSX) / 10): NGAY = INT((NGAY * 10 + NSY) / 10)
                IF NGAX <> 0 OR NGAY <> 0 THEN
                        NGAX = NGAX + SX: NGAY = NGAY + SY
                        BARFLAG = 1
                        NSX = (NSX MOD 10) + 1: NSY = (NSY MOD 10) + 1
                        TNSX = NSX: TNSY = NSY
                END IF
        END IF
        IF NSX < 1 THEN NSX = NSX + 10: TNSX = NSX: TNSY = NSY: BARFLAG = 1
        IF NSY < 1 THEN NSY = NSY + 10: TNSX = NSX: TNSY = NSY: BARFLAG = 1
        IF NGAX > 9 AND BARFLAG = 1 THEN NGAX = 9: GOSUB BARRIER: GOTO MENTRY
        IF NGAX < 1 AND BARFLAG = 1 THEN NGAX = 1: GOSUB BARRIER: GOTO MENTRY
        IF NGAY > 9 AND BARFLAG = 1 THEN NGAY = 9: GOSUB BARRIER: GOTO MENTRY
        IF NGAY < 1 AND BARFLAG = 1 THEN NGAY = 1: GOSUB BARRIER: GOTO MENTRY
        GOTO MENTRY
COLLISION: IF computer = 0 OR MAUTO = 0 THEN GOTO MCOLLISION
        JJ = -1 * INDEX + J
        TRAJECTORYJ = TRAJECTORY
        IF IX <> 0 THEN TRAJECTORYJ = CINT((SLOPE * (JJ - EX)) + EY)
        IF IX = 0 THEN TRAJECTORYJ = TRAJECTORYJ - INDEY
        DIST = SQR((EX - JJ) ^ 2 + (EY - TRAJECTORYJ) ^ 2) / 10
        ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
        ENERGY = ENERGY - ELOSS
        IF ENERGY < 0 THEN ENERGY = 0
        SDATE = SDATE + DIST / (SPEED * SPEED)
        SEC$(EX, EY) = "."
        EX = JJ: EY = TRAJECTORYJ
        IF KLINGS <> 0 THEN CONDITION = 3
        CALL MAKEDISPLAY
        COLOR RED, BACKGROUND
        PRINT NAVIGATOR$; " exclaims, ' Emergency stop activated, Captain !'"
        PRINT "We were about to collide with the ";
        IF SEC$(J, TRAJECTORY) = " " THEN PRINT "Black Hole ";
        IF SEC$(J, TRAJECTORY) = "K" THEN PRINT MENEMIES$;
        IF SEC$(J, TRAJECTORY) = "C" THEN PRINT MENEMIES$; " Commander ";
        IF SEC$(J, TRAJECTORY) = "P" THEN PRINT "planet ";
        IF SEC$(J, TRAJECTORY) = "S" THEN PRINT MENEMIES$; "Super Commander ";
        IF SEC$(J, TRAJECTORY) = CHR$(21) THEN PRINT benemies$; " ";
        IF SEC$(J, TRAJECTORY) = CHR$(15) THEN PRINT "star ";
        IF SEC$(J, TRAJECTORY) = "B" THEN PRINT "Star Base  ";
        IF SEC$(J, TRAJECTORY) = "R" THEN PRINT "Romulan ";
        PRINT "at "; STR$(J); ","; STR$(TRAJECTORY); "."
        COLOR BLUE, BACKGROUND
        EXIT SUB
MCOLLISION: COLOR RED, BACKGROUND: BEEP
        PRINT NAVIGATOR$; " screams, 'We're all going to die ! Collision !'"
        COLOR BLUE, BACKGROUND
        PRINT SHIP$; " collides with ";
        IF SEC$(J, TRAJECTORY) = " " THEN PRINT "Black Hole ";
        IF SEC$(J, TRAJECTORY) = "K" THEN PRINT MENEMIES$;
        IF SEC$(J, TRAJECTORY) = "C" THEN PRINT MENEMIES$; " Commander ";
        IF SEC$(J, TRAJECTORY) = "P" THEN PRINT "planet ";
        IF SEC$(J, TRAJECTORY) = "S" THEN PRINT MENEMIES$; "Super Commander ";
        IF SEC$(J, TRAJECTORY) = CHR$(21) THEN PRINT benemies$; " ";
        IF SEC$(J, TRAJECTORY) = CHR$(15) THEN PRINT "star ";
        IF SEC$(J, TRAJECTORY) = "B" THEN PRINT "Star Base  ";
        IF SEC$(J, TRAJECTORY) = "R" THEN PRINT "Romulan ";
        PRINT "at "; STR$(J); ","; STR$(TRAJECTORY); "."
        CALL DELAY(3)
        IF SEC$(J, TRAJECTORY) = " " THEN
                PRINT "The "; SHIP$; " was sucked down a Black Hole."
                IF RND > .2 THEN CALL ENDGAME: EXIT SUB
                CALL TIMEWARP
                EXIT SUB
        END IF
        IF RND * SPEED > 6 THEN CALL ENDGAME: EXIT SUB
        SEC$(EX, EY) = "."
NLOC:   EX = INT(8 * RND + 1): EY = INT(RND * 8 + 1)
        IF SEC$(EX, EY) <> "." THEN GOTO NLOC
        DIST = SQR((EX - JJ) ^ 2 + (EY - TRAJECTORYJ) ^ 2) / 10
        ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
        ENERGY = ENERGY - ELOSS
        IF ENERGY < 0 THEN ENERGY = 0
        SDATE = SDATE + DIST / (SPEED * SPEED)
        PRINT SHIP$; " thrown by force of collision to "; EX; ","; EY; "."
        IF 2 * RND * SPEED > SPEED * SHIELDS THEN
                PRINT "Computer Damaged ";
                DLEN(6) = RND * SPEED
                computer = 0
        END IF
        IF 2 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
                PRINT "All Weapons Damaged ";
                TORPEDOES = -1 * ABS(TORPEDOES)
                PHASORS = 0
                DLEN(4) = RND * SPEED
                DLEN(3) = DLEN(4) * RND
        END IF
        IF 2 * RND * SPEED > SPEED * (.5 + SHIELDS) THEN
                PRINT "Shields Damaged ";
                DLEN(2) = RND * SPEED
                SHIELDS = -1 * ABS(SHIELDS)
        END IF
        IF .5 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
                PRINT "Life support damaged ";
                life = 0
                DLEN(7) = RND * SPEED
        END IF
        IF .1 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
                PRINT "Crystals deterioriating ";
                CRYSTALS = 0
                DLEN(8) = 20 * (1 - RND) / SPEED
        END IF
        IF KLINGS <> 0 THEN CONDITION = 3
        PRINT
        CALL MAKEDISPLAY
        EXIT SUB
BARRIER: COLOR RED, BACKGROUND
        BEEP
        PRINT NAVIGATOR$; " exclaims, 'We have collided with the Energy Barrier which"
        PRINT "surrounds the Galaxy. Emergency stop executed.'"
        COLOR RED, BACKGROUND
        RETURN
END SUB

SUB PHASOR
        '
        '  This routine does the phaser fire control
        '
        SHARED SX, SY, SHIP$, EX, EY
        SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
        SHARED KLINGS, ENEMY, Klingons
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
        SHARED TRANSPORTER, C$, computer, BACKGROUND
        DIM THREATX(15), THREATY(15), THREATP(15), KEN(15), PFIRE(15)
        SCPEN = 0
        IF SHIELDS = 1 THEN SCPEN = SCPEN + .5
        IF CLOAK = 1 THEN SCPEN = SCPEN + .5
        IF PHASORS <> 1 THEN
                COLOR RED, BACKGROUND
                PRINT "Fire Control reporting, Sir. The Phasor generators won't fire."
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        I = LEN(C$) - 2: AUTO = 0: MAUTO = 1
        C$ = RIGHT$(C$, I)
        J = INSTR(C$, "M")
        IF J = 0 THEN AUTO = 1: J = INSTR(C$, "A")
        IF AUTO = 1 AND computer = 0 THEN
                CLS
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, 'We cannot fire the phasors on automatic with a damaged computer, Captain.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF J = 0 THEN COLOR RED, BACKGROUND: PRINT "Wrong syntax": COLOR BLUE, BACKGROUND: EXIT SUB
        I = LEN(C$)
        C$ = LTRIM$(RIGHT$(C$, I - J))
        I = LEN(C$)
        C$ = RTRIM$(C$)
        EPHAS = VAL(C$)
        IF EPHAS > 1000 AND ENERGY > 1000 THEN EPHAS = 1000
        IF EPHAS < 1 AND ENERGY > 1000 THEN EPHAS = 1000
        IF EPHAS < 1 AND ENERGY < 1000 THEN EPHAS = ENERGY / 2
        IF EPHAS < ENERGY AND ENERGY < 1000 THEN EPHAS = ENERGY / 2
        IF EPHAS > ENERGY THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " says, 'But Captain, we need a wee bit more energy to do that !'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        L = 0
        ECLOAK = 0
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        IF SEC$(I, J) = "K" OR SEC$(I, J) = "S" OR SEC$(I, J) = "C" OR (SEC$(I, J) = "R" AND STRENGTH(I, J) <= 1500) THEN
                                IF STRENGTH(I, J) <= 0 THEN
                                        COLOR RED, BACKGROUND
                                        PRINT WOFFICER$; " reports, 'Enemy ";
                                                IF WOFFICER$ = "Chekov" THEN PRINT "wessel";  ELSE PRINT "vessel";
                                        PRINT "at "; I; ","; J; " just exploded, Sir.'"
                                        COLOR BLUE, BACKGROUND
                                        IF SEC$(I, J) = "R" OR SEC$(I, J) = "." THEN
                                                ROMULANS = ROMULANS - 1
                                                SEC$(I, J) = "."
                                                STRENGTH(I, J) = 1000000!
                                                CALL SECDRAW
                                                GOTO NEXEN
                                        END IF
                                        Klingons = Klingons - 1
                                        ENEMY = ENEMY - 1
                                        STRENGTH(I, J) = 1000000!
                                        IF SEC$(I, J) = "K" THEN
                                                KLINGS = KLINGS - 1
                                                IF KLINGS < 1 THEN KLINGS = 0
                                                HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                                                HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                                                GAL$(SX, SY) = HGAL$(SX, SY)
                                        END IF
                                        SEC$(I, J) = "."
                                        CALL SECDRAW
                                        GOTO NEXEN
                                END IF
                                L = L + 1
                                THREATX(L) = I: THREATY(L) = J
                                THREATP(L) = SQR((I - EX) ^ 2 + (J - EY) ^ 2)
                                THREATP(L) = STRENGTH(I, J) / (THREATP(L) * 1000)
                        END IF
                        IF SEC$(I, J) = CHR$(21) THEN
                                COLOR RED, BACKGROUND
                                PRINT "COMPUTER : "; benemies$; " at "; I; ","; J; " has neutronium hull. Phasors usless against it."
                                COLOR BLUE, BACKGROUND
                        END IF
NEXEN:          NEXT J
        NEXT I
        FOR II = 1 TO L
                DIST = SQR((THREATX(II) - EX) ^ 2 + (THREATY(II) - EY) ^ 2)
                KEN(II) = 200 * THREATP(II) + 200 * (DIST * THREATP(II))
        NEXT II
        FOR I = 1 TO L
                FOR J = 2 TO I
                        IF THREATP(J) > THREATP(J - 1) THEN
                                TEMP = KEN(J - 1): KEN(J - 1) = KEN(J): KEN(J) = TEMP
                                TEMP = THREATX(J - 1): THREATX(J - 1) = THREATX(J): THREATX(J) = TEMP
                                TEMP = THREATY(J - 1): THREATY(J - 1) = THREATY(J): THREATY(J) = TEMP
                                TEMP = THREATP(J - 1): THREATP(J - 1) = THREATP(J): THREATP(J) = TEMP
                        END IF
                NEXT J
        NEXT I
        IF AUTO = 0 THEN GOTO PHMANUAL
        FOR I = 1 TO L
                IF SEC$(THREATX(I), THREATY(I)) = "." THEN GOTO PHAENDI
                IF KEN(I) * (1 + SCPEN) > EPHAS AND EPHAS <> 0 THEN GOTO PHADAMI
                EPHAS = EPHAS - (KEN(I) * (1 + SCPEN))
                ENERGY = ENERGY - (KEN(I) * (1 + SCPEN))
                STRENGTH(THREATX(I), THREATY(I)) = 0
                IF SEC$(THREATX(I), THREATY(I)) <> "R" THEN Klingons = Klingons - 1
                ENEMY = ENEMY - 1
                COLOR RED, BACKGROUND
                STRENGTH(I, J) = 1000000!
                IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at "; : KLINGS = KLINGS - 1
                IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
                PRINT THREATX(I); ","; THREATY(I); " DESTROYED. "; KEN(I); " units required."
                IF KLINGS < 1 THEN KLINGS = 0
                HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                GAL$(SX, SY) = HGAL$(SX, SY)
                IF SEC$(THREATX(I), THREATY(I)) = "C" THEN
                        commanders = commanders - 1
                        FOR SI = 1 TO 20
                                IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                        NEXT SI
                END IF
                IF SEC$(THREATX(I), THREATY(I)) = "S" THEN
                        SUPERS = SUPERS - 1
                        FOR SI = 1 TO 3
                                IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                        NEXT SI
                END IF
                IF SEC$(THREATX(I), THREATY(I)) = "R" THEN ROMULANS = ROMULANS - 1
                SEC$(THREATX(I), THREATY(I)) = "."
                GOTO PHAENDI
PHADAMI:        DIST = SQR((EX - THREATX(I)) ^ 2 + (EY - THREATY(I)) ^ 2)
                STRENGTH(THREATX(I), THREATY(I)) = STRENGTH(THREATX(I), THREATY(I)) - (EPHAS / DIST)
                IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";
                IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
                PRINT THREATX(I); ","; THREATY(I); " hit with "; (EPHAS / DIST); " units."
PHAENDI: NEXT I
        COLOR BLUE, BACKGROUND
        IF ENEMY < 1 THEN CONDITION = 1
        CALL MAKEDISPLAY
        EXIT SUB
PHMANUAL: COLOR RED, BACKGROUND: PRINT ENERGY; " units available to fire phasors."
        PFIRET = 0
        FOR I = 1 TO L
        IF computer = 1 THEN PRINT KEN(I) * (1 + SCPEN); " for a kill. ";
                PRINT "Units to fire at ";
                IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";
                IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "R" AND STRENGTH(THREATX(I), THREATY(I)) <= 1500 THEN PRINT "Romulan at ";
                PRINT THREATX(I); ","; THREATY(I); "  ";
                INPUT PFIRE(I)
        NEXT I
        FOR I = 1 TO L
                IF PFIRE(I) < KEN(I) AND KEN(I) <> 0 THEN GOTO MPHADAMI
                IF PFIRE(I) >= KEN(I) * (1 + SCPEN) THEN
                        ENERGY = ENERGY - PFIRE(I)
                        STRENGTH(THREATX(I), THREATY(I)) = 0
                        Klingons = Klingons - 1
                        ENEMY = ENEMY - 1
                        COLOR RED, BACKGROUND
                        STRENGTH(I, J) = 1000000!
                        IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at "; : KLINGS = KLINGS - 1
                        IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
                        IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
                        IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
                        PRINT THREATX(I); ","; THREATY(I); " DESTROYED. "; PFIRE(I); " units fired."
                        IF KLINGS < 1 THEN KLINGS = 0
                        HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                        HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                        GAL$(SX, SY) = HGAL$(SX, SY)
                        IF SEC$(THREATX(I), THREATY(I)) = "C" THEN
                                commanders = commanders - 1
                                FOR SI = 1 TO 20
                                        IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                                NEXT SI
                        END IF
                        IF SEC$(THREATX(I), THREATY(I)) = "S" THEN
                                SUPERS = SUPERS - 1
                                FOR SI = 1 TO 3
                                        IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                                NEXT SI
                        END IF
                        SEC$(THREATX(I), THREATY(I)) = "."
                        GOTO MPHAENDI
                END IF
MPHADAMI:       ENERGY = ENERGY - PFIRE(I)
                DIST = SQR((EX - THREATX(I)) ^ 2 + (EY - THREATY(I)) ^ 2)
                STRENGTH(THREATX(I), THREATY(I)) = STRENGTH(THREATX(I), THREATY(I)) - (PFIRE(I) / DIST)
                IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";
                IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
                IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
                PRINT THREATX(I); ","; THREATY(I); " hit with "; (PFIRE(I) / DIST); " units."
MPHAENDI:       PFIRET = PFIRET + PFIRE(I)
                IF PFIRET > 1000 AND RND > .5 THEN
                        COLOR RED, BACKGROUND
                        PRINT WOFFICER$; " reports, 'Phasors overheated, Captain !'"
                        PHASORS = 0
                        DLEN(3) = INT(30 * RND) / 10
                        GOTO PHEAT
                END IF
        NEXT I
PHEAT:  COLOR BLUE, BACKGROUND
        IF ENEMY < 1 THEN CONDITION = 1
        IF ENERGY < 0 THEN ENERGY = 0
        CALL MAKEDISPLAY
END SUB

SUB PROLOG
        '
        '       HERE WE TELL ABOUT THE GAME
        '
        SHARED MENEMIES$, LEVEL
        COLOR BLACK, BACKGROUND
        CLS
        COLOR RED, BACKGROUND
        PRINT "STARFLEET ORDERS, STARDATE:"; IDATE
        COLOR BLACK, BACKGROUND
        PRINT "Congratulations, you are now in command of the United"
        PRINT "Federation of Planets Starship, the U.S.S. Enterprise."
        PRINT "Unfortunately, negotiations with the "; MENEMIES$; "s have"
        PRINT "broken down. A state of war exists."
        PRINT ""
        PRINT "Your mission is most distasteful:"
        PRINT "You are to search out and destroy ";
        COLOR FRED, BACKGROUND
        PRINT "ALL ";
        COLOR BLACK, BACKGROUND
        PRINT MENEMIES$; "s that you encounter."
        PRINT
        IF LEVEL > 1 THEN
                PRINT "Intelligence reports that the Romulans are helping the "; MENEMIES$; "s"
                PRINT "and have just implemented a breakthrough in cloaking technology."
                COLOR RED, BACKGROUND
                PRINT
                PRINT "REPORTS ARE THAT EVEN WITH ALL SHORT RANGE SENSORS TRAINED ON"
                PRINT "ROMULAN SHIPS WITH THE NEW CLOAKING DEVICE, THEY WILL STAY"
                PRINT "INVISIBLE IF THEY HAVE ENOUGH POWER."
                PRINT
                COLOR BLACK, BACKGROUND
        END IF
        IF LEVEL = 2 THEN
                PRINT "Intelligence reports "; BERZERKS; " sightings of "; benemies$; "s"
                PRINT "recently. They are quite dangerous."
                PRINT
                PRINT "Intelligence also reports interception of "; MENEMIES$; " communications"
                PRINT "which may indicate as many as "; commanders + CINT(RND * 2); " "; MENEMIES$; " Commander Ships"
                PRINT "and at least one of the "; MENEMIES$; " Emperor's Super Commanders may be operational."
                PRINT
        END IF
        PRINT "Strike any key to begin your mission..."
READYTOGO: IF INKEY$ = "" THEN GOTO READYTOGO
END SUB

SUB REPAIRS
        '
        ' This routine checks to see if repairs are finished
        '
        ' DLEN(1) = DRIVE REPAIR TIME
        ' DLEN(2) = SHIELD REPAIR TIME
        ' DLEN(3) = PHASOR REPAIR TIME
        ' DLEN(4) = TORPEDOE TUBE REPAIR TIME
        ' DLEN(5) = CLOAK REPAIR TIME
        ' DLEN(6) = COMPUTER REPAIR TIME
        ' DLEN(7) = LIFE SUPPORT REPAIR TIME
        ' DLEN(8) = CRYSTAL DECAY TIME
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life, ODATE
        SHARED TRANSPORTER, SX, SY, SHIP$, CLOAK, computer, DLEN(), BACKGROUND
        DIM ELEN(8)
        FOR I = 1 TO 8
                ELEN(I) = DLEN(I)
        NEXT I
        IF CONDITION < 0 THEN
                FOR I = 1 TO 8
                        ELEN(I) = DLEN(I) / 20
                NEXT I
        END IF
        IF SDATE - ODATE > ELEN(1) AND ELEN(1) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " reports, 'Captain, the warp engines are operational."
                DLEN(1) = 0
        END IF
        IF SDATE - ODATE > ELEN(2) AND ELEN(2) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " reports, 'Captain, the shields are operational."
                DLEN(2) = 0
                SHIELDS = 1
        END IF
        IF SDATE - ODATE > ELEN(3) AND ELEN(3) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, 'Captain, the phasors are operational."
                DLEN(3) = 0
                PHASORS = 1
        END IF
        IF SDATE - ODATE > ELEN(4) AND ELEN(4) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " reports, 'Captain, the photon torpedoes are operational."
                DLEN(4) = 0
                TORPEDOES = -1 * TORPEDOES
        END IF
        IF SDATE - ODATE > ELEN(5) AND ELEN(5) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " reports, 'Captain, that cloaking contraption is operational."
                DLEN(5) = 0
                CLOAK = 1
        END IF
        IF SDATE - ODATE > ELEN(6) AND ELEN(6) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " reports, 'Captain, the ship's computers are operational."
                DLEN(6) = 0
                computer = 1
        END IF
        IF SDATE - ODATE > ELEN(7) AND ELEN(7) > 0 THEN
                COLOR RED, BACKGROUND
                PRINT "Engineering reports, 'Captain, the life support systems are operational."
                DLEN(7) = 0
                life = 1
        END IF
        IF SDATE - ODATE > ELEN(8) AND ELEN(8) > 0 AND CONDITION >= 0 THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " reports, 'Captain, the dilithium crystals are expended."
                DLEN(8) = 0
                ENERGY = 0
                SHIELDS = 0
        END IF
        IF SDATE - ODATE > ELEN(8) AND ELEN(8) > 0 AND CONDITION < 0 THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " reports, 'Captain, the dilithium crystals have been replaced."
                DLEN(8) = 0
                CRYSTALS = 1
        END IF
        FOR I = 1 TO 8
                IF DLEN(I) > 0 THEN DLEN(I) = DLEN(I) - ABS(SDATE - ODATE)
                IF DLEN(I) < 0 THEN DLEN(I) = 0
        NEXT I
        CALL MAKEDISPLAY
END SUB

SUB SETWARP
        '
        ' Here we set the warp speed
        '
        SHARED SPEED, drive, C$, BACKGROUND
        COLOR RED, BACKGROUND
        SPEED = VAL(RIGHT$(C$, 2))
        IF SPEED = 0 GOTO NSPEED
        GOTO SSPEED
NSPEED: PRINT "New warp setting (0-10) ";
        COLOR BLUE, BACKGROUND
        INPUT SPEED
SSPEED: IF SPEED < 0 OR SPEED > 10 THEN GOTO NSPEED
        IF SPEED < 1 THEN drive = 1 ELSE drive = 2
        IF SPEED = 0 THEN drive = 0
        CALL MAKEDISPLAY
END SUB

SUB SSCAN
        '
        '       THIS SUBROUTINE PERFORMS A SHORT-RANGE SCAN OF THE
        '       CURRENT SECTOR
        '
        SHARED SEC$(), PLANC(), EX, EY, SX, SY, PLANETS, BFLAG, PLANI(), PLANJ()
        SHARED BACKGROUND
        TIMER OFF
        VIEW PRINT 1 TO 25
        COLOR BLACK, BACKGROUND
        CLS
        PRINT
        PRINT
        PRINT SOFFICER$; " reports :"
        PRINT
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                IF SEC$(J, I) = "B" THEN PRINT "Star Base at sector "; J; ","; I; "."
                IF SEC$(J, I) = "K" THEN PRINT MENEMIES$; " at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
                IF SEC$(J, I) = "S" THEN PRINT MENEMIES$; " Super Commander at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
                IF SEC$(J, I) = "C" THEN PRINT MENEMIES$; " Commander at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
                IF SEC$(J, I) = "P" THEN
                        PRINT "Planet at "; J; ","; I;
                        FOR K = 1 TO PLANETS
                        IF PLANI(K) = SX AND PLANJ(K) = SY AND PLANC(K) = 1 THEN PRINT " of class M with indications of Dilithium Crystals.";
                        IF PLANI(K) = SX AND PLANJ(K) = SY AND PLANC(K) = 0 AND RND < .3 THEN PRINT " of class M with indications of Dilithium Crystals.";
                        NEXT K
                        PRINT ""
                END IF
                IF SEC$(J, I) = "E" OR SEC$(J, I) = "Q" THEN PRINT SHIP$; " located at "; J; ","; I; "."
                IF SEC$(J, I) = CHR$(21) THEN
                        PRINT benemies$; " at "; J; ","; I; " with a solid Neutronium hull."
                        IF BFLAG = 1 THEN PRINT "     The "; benemies$; " seems annoyed."
                END IF
                IF SEC$(J, I) = CHR$(15) THEN PRINT "Star at "; J; ","; I; "."
                IF SEC$(J, I) = "R" AND STRENGTH(J, I) < 1500 THEN PRINT "Romulan detected at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
                IF SEC$(J, I) = " " THEN PRINT "Black Hole at "; J; ","; I; "."
                NEXT J
        NEXT I
        PRINT "Hit any key ...."
WRANGE: A$ = INKEY$
        IF A$ = "" THEN GOTO WRANGE
        CLS
END SUB

SUB WORKSHEET
        '
        '       This subroutine makes a fake worksheet screen
        '
        '       User hits TAB to return to the game
        SHARED BACKGROUND
        TIMER OFF
SWORK:  VIEW PRINT 1 TO 25
        COLOR 7, 0
        CLS
        PRINT
        COLOR 7, 0
        PRINT
        PRINT
        COLOR BLACK, 7
        LOCATE 4, 1
        PRINT STRING$(79, " ");
        LOCATE 4, 1
        PRINT "       A         B         C         D         E         F         G         H  "
        FOR I = 1 TO 20
                COLOR BLACK, 7
                PRINT USING "##"; I;
                COLOR 7, 0
                PRINT USING " #.#######"; 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1);
                PRINT USING " #.#####"; 3 * RND(1)
        NEXT I
        COLOR 7, 0
        X = 3 * RND(1)
        COLOR 0, 7
        LOCATE 7, 64
        PRINT USING "#.#######"; X;
        COLOR 7, 0
        LOCATE 1, 1
        PRINT "G3:";
        PRINT USING "#.#######"; X;
        COLOR 16, 7: LOCATE 1, 76: PRINT "WAIT";
        COLOR 7, 0
HOLDITHERE: A$ = INKEY$
        IF A$ <> CHR$(9) THEN
                LOCATE 25, 1
                PRINT DATE$, TIME$;
                IF A$ = "%" THEN
                        CLS
                        PRINT
                        PRINT
                        PRINT
                        PRINT
                        PRINT
                        PRINT "SYSTEM ERROR - ST Keyboard Handler Error"
                        END
                END IF
                IF A$ = "/" THEN
                        CLS
                        PRINT
                        PRINT
                        PRINT
                        PRINT
                        PRINT
                        PRINT "Type EXIT to return to program..."
                        SHELL
                        GOTO SWORK
                END IF
                GOTO HOLDITHERE
        END IF
        COLOR BLACK, BACKGROUND
        CLS
        CALL MAKEDISPLAY
        TIMER ON
END SUB
