'
'    Module TREKMOD1.BAS
'
'    This version written by Burns Lab, University of Florida
'    Physics Department
'
'    Trek is an enhanced and expanded recreationn from memory of it's function, of Super Star Trek written around
'    1975 in Fortran, I believe by David Matuszek & Paul Reynolds with modifications by Don Smith.
'
'    Three modules must be compiled together in QuickBasic 4.5
'
'    TREK.BAS
'    TREKMOD1.BAS
'    TREKMOD2.BAS
'
'    Start Date: 1988 by Michael Burns
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <https://www.gnu.org/licenses/>.
'
'
'    BETA TEST VERSION 3.0  LAST UPDATE 5-JAN-91
'
'    Copyrigth 1991 by Michael Burns, US copyright registration number TX946379
'
DECLARE SUB TRANSPORT ()
DECLARE SUB SSCAN ()
DECLARE SUB ABANDON ()
DECLARE SUB CHNGCLOAK ()
DECLARE SUB COMMANDS ()
DECLARE SUB COMSCREEN ()
DECLARE SUB DELAY (X!)
DECLARE SUB DOCK ()
DECLARE SUB ENDGAME ()
DECLARE SUB GALDRAW ()
DECLARE SUB HELP ()
DECLARE SUB INITSECT ()
DECLARE SUB KATTACKS ()
DECLARE SUB LRSCAN ()
DECLARE SUB MAKEDISPLAY ()
DECLARE SUB MOVE ()
DECLARE SUB NOVA ()
DECLARE SUB PHASOR ()
DECLARE SUB PTORPEDOES ()
DECLARE SUB REPAIRS ()
DECLARE SUB REPAIRSTATUS ()
DECLARE SUB SECDRAW ()
DECLARE SUB SENERGY ()
DECLARE SUB SETWARP ()
DECLARE SUB SHIELD ()
DECLARE SUB SWAIT ()
DECLARE SUB SRANGESCAN ()
DECLARE SUB WORKSHEET ()
DECLARE SUB TIMEWARP ()
        DIM GAL$(9, 9), HGAL$(9, 9), OGAL$(9, 9), CGAL(9, 9)' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA, OGAL IS THE ORIGINAL
        DIM SEC$(10, 10), SUPI(3), SUPJ(3), BEZI(5), BEZJ(5), BEZA(5)
        DIM PLANI(10), PLANJ(10), PLANC(10), COMI(20), COMJ(20), ROMI(20), ROMJ(20)
        DIM STRENGTH(9, 9), DLEN(8), BSI(5), BSJ(5)
        COMMON SHARED /GALAXY/ GAL$(), HGAL$(), OGAL$(), CGAL(), LEVEL' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA
        COMMON SHARED /SECTOR1/ SEC$(), SUPI(), SUPJ(), BEZI(), BEZJ(), BEZA()
        COMMON SHARED /SECTOR2/ PLANI(), PLANJ(), PLANC(), COMI(), COMJ(), ROMI(), ROMJ()
        COMMON SHARED /SECTOR3/ STRENGTH(), DLEN(), PLANETS, TDOWN, HEREWEARE
        COMMON SHARED /SHIP1/ drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        COMMON SHARED /SHIP2/ SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, ODATE, life
        COMMON SHARED /SHIP3/ TRANSPORTER, SX, SY, SHIP$, CLOAK, computer, EX, EY
        COMMON SHARED /BASEINFO/ BASES, HELPCOUNT
        COMMON SHARED /ENEMIES1/ BERZERKS, KLINGONS, COMMANDERS, SUPERS, ENEMY, KLINGS
        COMMON SHARED /ENEMIES2/ EATEN, ECLOAK, BFLAG, ROMULANS, oromulans
        COMMON SHARED /ENDGAMEINFO1/ OKLINGONS, OCOMMANDERS, OSUPERS, OROLULANS, ENDOFGAME
        COMMON SHARED /ENDGAMEINFO2/ KBERZERKERS, BASEDESTROYED, PLANETSLOST, IDATE
        COMMON SHARED /STRINGS/ C$, BACKGROUND
        COMMON SHARED /colors/ BLUE, RED, GREEN, FRED, FBLUE, BLACK, PURPLE, ORANGE
        COMMON SHARED /PLAYERS/ DOCTOR$, ENGINEER$, WOFFICER$, COFFICER$, SOFFICER$, NAVIGATOR$, MENEMIES$, BENEMIES$
GETCOM2: COLOR BLUE, BACKGROUND: TIMER ON
        IF KLINGONS < 1 THEN CALL ENDGAME
        X = FRE("")
        COLOR RED, BACKGROUND
        X = POS(0)
        Y = CSRLIN
        LOCATE 25, 1
        PRINT "Press ? <Enter> for command list, Press F1 for help    ";
        LOCATE Y, X
        COLOR BLUE, BACKGROUND
        PRINT "Command ? ";
WCOM2:   A$ = INKEY$: IF A$ = "" THEN GOTO WCOM2
        IF A$ = CHR$(14) THEN CLS : GOTO GETCOM2
        COLOR BLACK, BACKGROUND
        PRINT A$;
        LINE INPUT ""; C$
        C$ = A$ + C$
        CLS
        ODATE = SDATE
        C$ = UCASE$(C$)
        C$ = LTRIM$(C$): C$ = RTRIM$(C$)
        IF C$ = "ABANDON" THEN CALL ABANDON: GOTO GETCOM2
        IF LEFT$(C$, 2) = "CL" THEN CALL CHNGCLOAK: CALL KATTACKS: GOTO UNIVRESPONSE
        IF C$ = "D" OR C$ = "DOCK" THEN CALL DOCK: GOTO UNIVRESPONSE
        IF C$ = "?" THEN CALL COMMANDS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 4) = "HELP" THEN CALL HELP: GOTO UNIVRESPONSE
        IF C$ = "L" OR C$ = "LONG" THEN CALL LRSCAN: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "M " THEN CALL MOVE: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "T " THEN CALL PTORPEDOES: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "TR" THEN CALL TRANSPORT: GOTO UNIVRESPONSE
        IF LEFT$(C$, 1) = "P" THEN CALL PHASOR: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "SE" THEN CALL SENERGY: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "SH" THEN CALL SHIELD: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "WA" THEN CALL SWAIT: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 1) = "W" THEN CALL SETWARP
        IF LEFT$(C$, 2) = "RS" THEN CALL REPAIRSTATUS
        IF LEFT$(C$, 1) = "F" THEN CALL WORKSHEET
        IF C$ = "S" THEN
                CALL SSCAN
                VIEW PRINT 1 TO 24
                CLS
                CALL MAKEDISPLAY
        END IF
        IF C$ = "QUIT" THEN CALL ENDGAME
        IF ENDOFGAME = 1 THEN
                PRINT "Sorry, memory is fractured. You must restart TREK form DOS."
                END
        END IF
UNIVRESPONSE: CALL REPAIRS
        GOTO GETCOM2
ERROR2: COLOR RED, BACKGROUND
        PRINT "Say what ?"
        COLOR BLUE, BACKGROUND: PRINT : PRINT
        RESUME GETCOM2

SUB ABANDON
        '
        ' This routine allows one to abandon the Enterprise as
        ' long as there is a Star Base. If no bases, you die.
        '
        SHARED SHIP$, BACKGROUND
        TIMER OFF
        IF CONDITION < 0 THEN
                COLOR RED, BACKGROUND
                PRINT DOCTOR$; " exclaims, 'Are you having those memory lapses again, Captain ?'"
                COLOR BLUE, BACKGROUND
                TIMER ON
                EXIT SUB
        END IF
        BEEP
        COLOR RED, BACKGROUND
        PRINT "ABANDON SHIP ! ABANDON SHIP ! ALL HANDS, ABANDON SHIP !"
        BEEP
ABTIME1: CALL DELAY(5)
        IF BASES = 0 THEN
                COLOR RED, BACKGROUND
                PRINT "You and your crew drift in lifeboats for months, starving"
                PRINT "to death while the "; MENEMIES$; "s win the war. Your name becomes "
                PRINT "equated with cowardice."
ABTIME2:        CALL DELAY(5)
                COLOR BLUE, BACKGROUND
                SHIP$ = "U.S.S. FARIE QUEENE"
                CALL ENDGAME: EXIT SUB
                EXIT SUB
        END IF
        IF SHIP$ = "U.S.S. FARIE QUEENE" THEN
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " says, 'Star Fleet will execute us if we abandon again, Captain.'"
                PRINT "  'I think I would rather disobey this order.'"
                COLOR BLUE, BACKGROUND
                TIMER ON
                EXIT SUB
        END IF
        TIMER OFF
        VIEW PRINT 1 TO 24
        CLS
        COLOR RED, BACKGROUND
        PRINT "You and your crew drift in space for weeks. Finally, you are rescued"
        PRINT "by a Alligatorian brothel-boat and returned to Star Fleet. After much"
        PRINT "deliberation, it is decided to let you have another ship, although you"
        PRINT "cannot be trusted with one of the good ones. You are given command of"
        PRINT "the U.S.S. Farie Queene."
        COLOR BLUE, BACKGROUND
ABTIME3: CALL DELAY(15)
        SHIP$ = "U.S.S. FARIE QUEENE"
        ENERGY = 10000
        TORPEDOES = 10
        SHENERGY = 5000
        FOR I = 1 TO 9
        FOR J = 1 TO 9
        X = 0
        X = INSTR(GAL$(I, J), "B")
        IF X <> 0 THEN GOTO PBASE
        NEXT J
        NEXT I
PBASE:  SX = I: SY = J
        EX = INT(8 * RND) + 1: EY = INT(8 * RND) + 1
        CONDITION = -1
        CLS
        LOCATE 24, 1
        CALL INITSECT
        CALL MAKEDISPLAY
        TIMER ON
END SUB

SUB CHNGCLOAK
        '
        ' This routine changes the cloaking device status
        '
        SHARED BACKGROUND
        IF CLOAK = 1 OR CLOAK = 0 THEN ENERGY = ENERGY - 100
        IF ENERGY <= 0 THEN ENERGY = 0: COLOR RED, BACKGROUND: PRINT "NO ENERGY": CALL MAKEDISPLAY: EXIT SUB
        IF CLOAK = 0 THEN CLOAK = 1: CALL MAKEDISPLAY: EXIT SUB
        IF CLOAK = 1 THEN CLOAK = 0: CALL MAKEDISPLAY: EXIT SUB
        IF CLOAK < 0 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'Cloaking Device damaged, Captain.'"
                EXIT SUB
        END IF

END SUB

SUB DOCK
        '
        ' Here we dock the enterprise
        '
        SHARED ENERGY, TORPEDOES, SHENERGY, EX, EY, SEC$(), SHIP$, TDOWN, BACKGROUND
        X = 0: TDOWN = 0
        FOR I = EX - 1 TO EX + 1
                FOR J = EY - 1 TO EY + 1
                        IF J < 1 OR J > 9 THEN GOTO DENDJ
                        IF I < 1 OR I > 9 THEN GOTO DENDI
                        X = X + INSTR(SEC$(I, J), "B")
DENDJ:          NEXT J
DENDI:  NEXT I
        IF X = 0 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'We are not at a Star Base, Captian.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        CONDITION = -1 * CONDITION
        IF SHIP$ = "U.S.S. ENTERPRISE" THEN
                ENERGY = 20000
                TORPEDOES = 20
                SHENERGY = 10000
        ELSE
                ENERGY = 10000
                TORPEDOES = 10
                SHENERGY = 5000
        END IF
        CALL MAKEDISPLAY
END SUB

SUB ENDGAME
        '
        ' Here we end the game
        '
        SHARED ENDOFGAME, HELPCOUNT, BASEDESTROYED, PLANETSLOST, KLINGONS, OKLINGONS
        SHARED SUPERS, OSUPERS, ROMULANS, oromulans, COMMANDERS, OCOMMANDERS, KBERZERKERS
        SHARED SDATE, IDATE, BACKGROUND
        TIMER OFF
        VIEW PRINT 1 TO 24
        CLS
        HELPPOINTS = -500 * HELPCOUNT
        BASEPOINTS = -5000 * BASEDESTROYED
        PLANETPOINTS = -1000 * PLANETSLOST
        KLINGONPOINTS = 100 * (OKLINGONS - KLINGONS)
        SUPERPOINTS = 1000 * (OSUPERS - SUPERS)
        ROMPOINTS = 500 * (oromulans - ROMULANS)
        COMMPOINTS = 500 * (OCOMMANDERS - COMMANDERS)
        BERZERKPOINTS = 3000 * KBERZERKERS
        TIMEPOINTS = -100 * (SDATE - IDATE)
        IF SHIP$ = "U.S.S. FARIE QUEENE" THEN ABANDONPTS = -5000
        POINTOTAL = BASEPOINTS + PLANETPOINTS + KLINGONPOINTS + SUPERPOINTS + ROMPOINTS
        POINTOTAL = POINTOTAL + COMMPOINTS + BERZERKPOINTS + TIMEPOINTS + HELPPOINTS
        POINTOTAL = POINTOTAL + ABANDONPTS
        COLOR RED, BACKGROUND
        PRINT "Your score for this game is as follows:"
        IF KLINGONPOINTS <> 0 THEN PRINT (OKLINGONS - KLINGONS); " "; MENEMIES$; " Kills :   "; KLINGONPOINTS
        IF COMMPOINTS <> 0 THEN PRINT (OCOMMANDERS - COMMANDERS); " Commander Kills : "; COMMPOINTS
        IF SUPERPOINTS <> 0 THEN PRINT (OSUPERS - SUPERS); " Super Commander Kills : "; SUPERPOINTS
        IF ROMPOINTS <> 0 THEN PRINT (oromulans - ROMULANS); " Romulan Kills : "; ROMPOINTS
        IF BERZERKPOINTS <> 0 THEN PRINT KBERZERKERS; " "; BENEMIES$; " Kills : "; BERZERKPOINTS
        IF BASEPOINTS <> 0 THEN
                PRINT "For destroying "; BASEDESTROYED; " Star Bases : "; BASEPOINTS
        END IF
        IF PLANETPOINTS <> 0 THEN
                PRINT "For destroying "; PLANETSLOST; " Planets : "; PLANETPOINTS
        END IF
        BFLAG = 0
        FOR I = 1 TO BERZERKS
                IF BEZA(I) = 1 THEN BFLAG = BFLAG + 1
        NEXT I
        IF BFLAG <> 0 THEN
                PRINT "For being dumb enough to annoy a "; BENEMIES$; " : "; -1 * BFLAG * 200
        END IF
        IF HELPCOUNT > 0 THEN PRINT "For needing to be helped by a Star Base : "; HELPPOINTS
        IF EATEN <> 0 THEN PRINT "For letting a "; BENEMIES$; " kill you : -2000"
        IF SHIP$ = "U.S.S. FARIE QUEENE" THEN PRINT "For abandoning the Enterprise : -5000"
        PRINT "For taking your sweet "
        PRINT "time on this mission : "; TIMEPOINTS
        PRINT
        POINTOTAL = POINTOTAL - 1 * BFLAG * 200 - 2000 * EATEN
        PRINT "TOTAL SCORE : "; POINTOTAL
        PRINT : PRINT : PRINT : PRINT
        PRINT "Would you like to play another game (<cr>=Y) "; : INPUT A$
        IF A$ = "" THEN A$ = "Y"
        A$ = UCASE$(A$)
        IF LEFT$(A$, 1) = "N" THEN
                COLOR 7, 0
                SCREEN 0
                CLS
                END
        END IF
        ENDOFGAME = 1
END SUB

SUB GALDRAW STATIC
        '
        ' This subroutine redraws the whole GALAXY MAP
        '
        SHARED SX, SY, GAL$(), CONDITION, BACKGROUND
        TIMER OFF
        IF SX < 1 THEN SX = 1
        IF SX > 9 THEN SX = 9
        IF SY < 1 THEN SY = 1
        IF SY > 9 THEN SY = 9
        CRG = CSRLIN: CCG = POS(0)
        VIEW PRINT 1 TO 24
        COLOR BLUE, BACKGROUND
        LOCATE 1, 1
        PRINT "            Explored Galaxy Map                    "
        PRINT
        PRINT "     1   2   3   4   5   6   7   8   9         "
        FOR I = 1 TO 9
        COLOR BLUE, BACKGROUND
        PRINT STR$(I); " ";
        COLOR BLACK, BACKGROUND
        FOR J = 1 TO 9
        IF SX = J AND SY = I THEN
                COLOR FRED, BACKGROUND
                PRINT " "; GAL$(J, I);
                COLOR BLACK, BACKGROUND
                GOTO ENDGAL
        END IF
        IF INSTR(GAL$(J, I), "B") <> 0 THEN COLOR PURPLE, BACKGROUND ELSE COLOR BLACK, BACKGROUND
        PRINT " "; GAL$(J, I);
ENDGAL: NEXT J
        COLOR BLUE, BACKGROUND
        PRINT STR$(I)
        NEXT I
        VIEW PRINT 21 TO 24
        IF CRG < 21 THEN CRG = 24: CCG = 1
        LOCATE CRG, CCG
        IF CONDITION >= 0 THEN TIMER ON
END SUB

SUB HELP
        '
        ' We do the response for help here
        '
        SHARED SX, SY, EX, EY, BASES, CONDITION, GAL$(), HELPCOUNT, BACKGROUND
        DIM BASEX(6), BASEY(6), BASED(6)
        HELPCOUNT = HELPCOUNT + 1
        IF CONDITION < 0 THEN
                COLOR RED, BACKGROUND
                PRINT DOCTOR$; " exclaims, 'Are you having those memory lapses again, Captain ?'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF BASES = 0 THEN
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " says, 'No bases left, Captain. We are on our own.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        CLS
        COLOR BLUE, BACKGROUND
        PRINT "Star Fleet attempts to use the experimental (Patent Pending)";
        COLOR RED, BACKGROUND
        PRINT " GALACTIC TRANSPORTER BEAM."
        COLOR BLUE, BACKGROUND
        BAS = 0
        FOR I = 1 TO 9
        FOR J = 1 TO 9
        X = 0
        X = INSTR(GAL$(I, J), "B")
        IF X <> 0 THEN
                BAS = BAS + 1
                BASEX(BAS) = I
                BASEY(BAS) = J
                BASED(BAS) = SQR((I - SX) ^ 2 + (J - SY) ^ 2)
        END IF
        NEXT J
        NEXT I
        NEARX = BASEX(BAS)
        NEARY = BASEY(BAS)
        NEARD = BASED(BAS)
        FOR I = 1 TO BAS
                IF BASED(I) < NEARD THEN
                        NEARX = BASEX(I)
                        NEARY = BASEY(I)
                        NEARD = BASED(I)
                END IF
        NEXT I
        PRINT "Nearest Star Base is in quadrant "; NEARX; ","; NEARY
HELPDELAY1: CALL DELAY(2)
        FOR I = 1 TO 3
                PRINT "Materialization attempt # "; I; " ";
HELPDELAY2:     CALL DELAY(.5)
                IF 50 * RND > NEARD ^ 2 THEN
                        COLOR RED, BACKGROUND
                        PRINT "SUCCEEDS !!"
                        COLOR BLUE, BACKGROUND
                        SX = NEARX: SY = NEARY
                        EX = INT(8 * RND) + 1: EY = INT(8 * RND) + 1
                        CONDITION = -1
                        CALL INITSECT
                        CALL MAKEDISPLAY
                        EXIT SUB
                ELSE
                        PRINT "FAILS"
                END IF
        NEXT I
        CLS
        COLOR RED, BACKGROUND: PRINT "Star Fleet to Enterprise: We cannot help you."
        PRINT "Good Luck Enterprise..."
        COLOR BLUE, BACKGROUND
HELPDELAY3: CALL DELAY(3)
END SUB

SUB INITSECT
        '
        ' We intinalize the current sector upon entry of the Enterprise
        '
        SHARED SX, SY, SHIP$, EX, EY, BEZI(), BEZJ(), BEZA()
        SHARED ROMULANS, COMMANDERS, SUPERS, BERZERKERS, PLANETS, BASES
        SHARED CONDITION, KLINGS, ENEMY, LEVEL, BACKGROUND
        ON ERROR GOTO ERROR2
        COMMS = 0: KLINGS = 0: RKLINGS = 0: ENEMY = 0
        KEY(1) ON
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        SEC$(I, J) = "."
                        STRENGTH(I, J) = 1000000!
                NEXT J
        NEXT I
        SEC$(EX, EY) = "E"    ' Place Enterprise at its entry location

        BFLAG = 0
        FOR I = 1 TO BERZERKS
                IF BEZA(I) = 1 THEN BEZI(I) = SX: BEZJ(I) = SY: BFLAG = BFLAG + 1
        NEXT I
        IF BFLAG = 1 THEN
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " reports, 'That "; BENEMIES$; " we annoyed has followed"
                PRINT "us to this quadrant, Captain.'"
                COLOR BLUE, BACKGROUND
        END IF
        IF BFLAG > 1 THEN
                COLOR RED, BACKGROUND
                PRINT "'Fascinating !' exclaims "; SOFFICER$; ". 'There are now "; BFLAG; " of them following us."
                PRINT "The "; BENEMIES$; "s seem to be cooperating in order to destroy us.'"
                COLOR BLUE, BACKGROUND
        END IF
        IF CONDITION < 0 THEN
DOCKED:         X = CINT(RND): Y = CINT(RND)
                X = 2 * X - 1: Y = 2 * Y - 1
                IF (X + EX) < 1 OR (X + EX) > 9 THEN GOTO DOCKED
                IF (Y + EY) < 1 OR (Y + EY) > 9 THEN GOTO DOCKED
                SEC$(X + EX, Y + EY) = "B"
                GOTO SBERZ
        END IF
        IF INSTR(HGAL$(SX, SY), "B") <> 0 THEN
IBASE:          X = INT(8 * RND) + 1: Y = INT(8 * RND)
                IF SEC$(X, Y) <> "." THEN GOTO IBASE
                SEC$(X, Y) = "B"
        END IF
SBERZ:  FOR I = 1 TO BERZERKS
        IF BEZI(I) <> SX OR BEZJ(I) <> SY THEN GOTO EBERZ
IBERZ:  X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO IBERZ
        SEC$(X, Y) = CHR$(21): ENEMY = ENEMY + 1
EBERZ:  NEXT I
        IF ROMULANS > 0 AND RND > .2 THEN
                ROM = 3 * RND
                IF ROM > ROMULANS THEN ROM = ROMULANS
                FOR I = 1 TO ROM
IROM:                   X = INT(8 * RND) + 1: Y = INT(8 * RND)
                        SEC$(X, Y) = "R"
                        STRENGTH(X, Y) = 1000 + 1500 * RND
                NEXT I
        END IF
        FOR I = 1 TO PLANETS
        IF PLANI(I) <> SX OR PLANJ(I) <> SY THEN GOTO EPLAN
IPLAN:  X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO IPLAN
        SEC$(X, Y) = "P"
EPLAN:  NEXT I
        FOR I = 1 TO SUPERS
        IF SUPI(I) <> SX OR SUPJ(I) <> SY THEN GOTO ESUP
ISUP:   X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO ISUP
        SEC$(X, Y) = "S"
        STRENGTH(X, Y) = 3000: ENEMY = ENEMY + 1
ESUP:   NEXT I
        FOR I = 1 TO COMMANDERS
        IF COMI(I) <> SX OR COMJ(I) <> SY THEN GOTO ECOM
ICOM:   X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO ICOM
        SEC$(X, Y) = "C"
        STRENGTH(X, Y) = 1500: ENEMY = ENEMY + 1
ECOM:   NEXT I
        IF RIGHT$(HGAL$(SX, SY), 1) = " " THEN STARS = 0 ELSE STARS = VAL(RIGHT$(HGAL$(SX, SY), 1))
        IF LEFT$(HGAL$(SX, SY), 1) = " " THEN KLINGONI = 0 ELSE KLINGONI = VAL(LEFT$(HGAL$(SX, SY), 1))
        GAL$(SX, SY) = RIGHT$(HGAL$(SX, SY), 3)
        FOR I = 1 TO KLINGONI
IKLINGS: X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO IKLINGS
        SEC$(X, Y) = "K": KLINGS = KLINGS + 1: RKLINGS = RKLINGS + 1
        STRENGTH(X, Y) = 1000: ENEMY = ENEMY + 1
        NEXT I
        IF LEVEL = 1 THEN GOTO IISTARS
IBHOLES: BHOLES = CINT(LEVEL * RND)
        FOR I = 1 TO BHOLES
IIBHOLES: X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO IIBHOLES
        SEC$(X, Y) = " "
        NEXT I
IISTARS: FOR I = 1 TO STARS
ISTARS: X = INT(8 * RND) + 1: Y = INT(8 * RND)
        IF SEC$(X, Y) <> "." THEN GOTO ISTARS
        SEC$(X, Y) = CHR$(15)
        NEXT I
        IF KLINGS > 0 THEN
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, '"; KLINGS; " "; MENEMIES$; "s in this quadrant !'"
                IF KLINGS > RKLINGS THEN PRINT "That's "; (KLINGS - RKLINGS); " more than Long Range Sensors indicated.'"
                IF KLINGS > RKLINGS THEN PRINT "'They seem to have been using a long range cloaking device, Captain.'"
                COLOR BLUE, BACKGROUND
        END IF
        IF ENEMY > 0 THEN CONDITION = 3
        EXIT SUB
END SUB

SUB KATTACKS
        '
        ' This is where the Klingons and Romulans attack the ship
        '
        SHARED SX, SY, SHIP$, EX, EY
        SHARED ROMULANS, COMMANDERS, SUPERS, BERZERKS, PLANETS, BASES
        SHARED KLINGS, ENEMY, KLINGONS
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
        SHARED TRANSPORTER, C$, computer, BACKGROUND
        SUPHERE = 0
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        IF SEC$(I, J) = "S" THEN SUPHERE = 1
                NEXT J
        NEXT I
        IF ECLOAK = 1 AND RND < .9 AND SUPHERE = 0 THEN EXIT SUB
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        IF SEC$(I, J) <> "R" AND SEC$(I, J) <> "K" AND SEC$(I, J) <> "C" AND SEC$(I, J) <> "S" THEN GOTO KATTENDJ
                        IF STRENGTH(I, J) > 4000 THEN STRENGTH(I, J) = 4000
                        IF STRENGTH(I, J) <= 0 THEN
                                COLOR RED, BACKGROUND
                                PRINT WOFFICER$; " reports, 'Enemy ";
                                        IF WOFFICER$ = "Chekov" THEN PRINT "wessel";  ELSE PRINT "vessel";
                                PRINT " at "; I; ","; J; " just exploded, Sir.'"
                                COLOR BLUE, BACKGROUND
                                ENEMY = ENEMY - 1: KLINGONS = KLINGONS - 1
                                IF SEC$(I, J) = "S" THEN
                                        SUPERS = SUPERS - 1
                                        FOR SI = 1 TO 3
                                                IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                                        NEXT SI
                                END IF
                                IF SEC$(I, J) = "C" THEN
                                        COMMANDERS = COMMANDERS - 1
                                        FOR SI = 1 TO 20
                                                IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                                        NEXT SI
                                END IF
                                IF SEC$(I, J) = "K" THEN
                                        KLINGS = KLINGS - 1
                                        IF KLINGS < 1 THEN KLINGS = 0
                                        HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                                        HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                                        GAL$(SX, SY) = HGAL$(SX, SY)
                                END IF
                                IF SEC$(I, J) = "R" THEN ROMULANS = ROMULANS - 1
                                SEC$(I, J) = "."
                                CALL SECDRAW
                                GOTO KATTENDJ
                        END IF
                        DIST = SQR((EX - I) ^ 2 + (EY - J) ^ 2)
                        EPHAS = STRENGTH(I, J) / (2 * DIST)
                        IF SHIELDS = 1 THEN SHENERGY = SHENERGY - EPHAS
                        COLOR RED, BACKGROUND
                        PRINT EPHAS; " unit Phasor hit from ";
                        IF SEC$(I, J) = "R" THEN PRINT "Romulan ";
                        IF SEC$(I, J) = "K" THEN PRINT MENEMIES$; " ";
                        IF SEC$(I, J) = "C" THEN PRINT MENEMIES$; " Commander ";
                        IF SEC$(I, J) = "S" THEN PRINT MENEMIES$; " Super Commander ";
                        PRINT "at sector "; I; ","; J
                        IF SHENERGY < 0 THEN SHIELDS = 0: SHENERGY = 0
                        COLOR RED, BACKGROUND
                        IF RND > SHIELDS * SPERCENT THEN
                                PRINT "Computer Damaged ";
                                DLEN(6) = DLEN(6) + RND * (EPHAS / 1000)
                                computer = 0
                                GOTO KATTENDJ
                        END IF
                        IF RND > SHIELDS * SPERCENT THEN
                                PRINT "Phasors damaged. ";
                                DLEN(3) = DLEN(3) + RND * (EPHAS / 1000)
                                PHASORS = 0
                                GOTO KATTENDJ
                        END IF
                        IF RND > SHIELDS * SPERCENT THEN
                                PRINT "Photon torpedoe tubes damaged.";
                                DLEN(4) = DLEN(4) + RND * (EPHAS / 1000)
                                TORPEDOES = -1 * ABS(TORPEDOES)
                                GOTO KATTENDJ
                        END IF
                        IF RND > 10 * SHIELDS * SPERCENT THEN
                                PRINT "All weapons damaged.";
                                DLEN(4) = DLEN(4) + RND * (EPHAS / 1000)
                                DLEN(3) = DLEN(3) + RND * (EPHAS / 1000)
                                PHASORS = 0
                                GOTO KATTENDJ
                        END IF
                        IF RND > SHIELDS * SPERCENT THEN
                                PRINT "Shields damaged ";
                                DLEN(2) = DLEN(2) + RND * (EPHAS / 1000)
                                SHIELDS = -1 * ABS(SHIELDS)
                                GOTO KATTENDJ
                        END IF
                        IF RND > 10 * SHIELDS * SPERCENT THEN
                                PRINT "Life support damaged ";
                                life = 0
                                DLEN(7) = DLEN(7) + RND * (EPHAS / 1000)
                                GOTO KATTENDJ
                        END IF
                        IF RND > 20 * SHIELDS * SPERCENT THEN
                                PRINT "Crystals deterioriating ";
                                CRYSTALS = 0
                                DLEN(8) = DLEN(8) + RND * (EPHAS / 1000)
                                GOTO KATTENDJ
                        END IF
                        IF KLINGS <> 0 THEN CONDITION = 3

KATTENDJ:       COLOR BLUE, BACKGROUND
                NEXT J
        NEXT I
        CALL MAKEDISPLAY
END SUB

SUB LRSCAN
        '
        ' Here we perform a long range scan and update the galaxy map
        '
        SHARED SX, SY, GAL$(), HGAL$(), BACKGROUND
        FOR I = SX - 1 TO SX + 1
                FOR J = SY - 1 TO SY + 1
                       IF I <= 0 OR I > 9 OR J <= 0 OR J > 9 THEN GOTO ESCAN
                      GAL$(I, J) = RIGHT$(HGAL$(I, J), 3)
ESCAN:          NEXT J
        NEXT I
        CALL GALDRAW
END SUB

SUB MAKEDISPLAY STATIC
        '
        'This subroutine sets up the bridge display. The display
        'contains the sector and explored galaxy maps as well as
        'the system status information. It assumes an CGA display.
        '
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
        SHARED TRANSPORTER, SX, SY, SHIP$, CLOAK, computer
        SHARED KLINGONS, COMMANDERS, SUPERS, BACKGROUND, MENEMIES$
        IF CONDITION < 0 AND SHIP$ = "U.S.S. ENTERPRISE" THEN
                ENERGY = 20000
                TORPEDOES = 20
                CRYSTALS = 1
                SHENERGY = 10000
        END IF
        IF CONDITION < 0 AND SHIP$ = "U.S.S. FARIE QUEENE" THEN
                ENERGY = 10000
                TORPEDOES = 10
                CRYSTALS = 1
                SHENERGY = 5000
        END IF
        CALL SECDRAW
        CALL GALDRAW
        CRM = CSRLIN: CCM = POS(0)
        VIEW PRINT 1 TO 24
        LOCATE 14, 1
        PRINT "Ship Status , "; SHIP$; "               ";
        COLOR BLUE, BACKGROUND: PRINT "STARDATE : "; : COLOR BLACK, BACKGROUND: PRINT SDATE: PRINT
        COLOR BLUE, BACKGROUND: PRINT "ENERGY : "; : COLOR BLACK, BACKGROUND: PRINT ENERGY; "   "
        COLOR BLUE, BACKGROUND: PRINT "DRIVE : ";
        IF drive = 2 THEN COLOR BLACK, BACKGROUND: PRINT "  WARP  "
        IF drive = 1 THEN COLOR ORANGE, BACKGROUND: PRINT " IMPULSE"
        IF drive = 0 THEN COLOR FRED, BACKGROUND: PRINT " NONE   "
        COLOR BLUE, BACKGROUND: PRINT "SPEED : ";
        IF SPEED < 7.5 THEN COLOR BLACK, BACKGROUND: PRINT " WARP "; SPEED ELSE COLOR FRED, BACKGROUND: PRINT " WARP "; SPEED
        COLOR BLUE, BACKGROUND: PRINT "LIFE SUPPORT : ";
        IF life = 1 THEN COLOR GREEN, BACKGROUND: PRINT "ACTIVE"
        IF life = 0 THEN COLOR FRED, BACKGROUND: PRINT "FAILED"
        COLOR BLUE, BACKGROUND: PRINT "CLOAK : ";
        IF CLOAK = 0 THEN COLOR ORANGE, BACKGROUND: PRINT "DOWN  " ELSE COLOR GREEN, BACKGROUND: PRINT "ACTIVE"
        LOCATE 19, 25
        COLOR BLUE, BACKGROUND: PRINT "SHIELDS : ";
        IF SHIP$ = "U.S.S. FARIE QUEENE" THEN SPERCENT = INT(SHENERGY / 10) / 5
        IF SHIP$ = "U.S.S. ENTERPRISE" THEN SPERCENT = INT(SHENERGY / 10) / 10
        IF SHIELDS = 0 THEN COLOR BLACK, BACKGROUND: PRINT "DOWN   "; SPERCENT; " %  ";
        IF SHIELDS = 1 THEN COLOR RED, BACKGROUND: PRINT "UP     "; SPERCENT; " %  ";
        IF SHIELDS < 0 THEN COLOR FRED, BACKGROUND: PRINT "DAMAGED";
        LOCATE 16, 25
        IF ENEMY = 0 AND CONDITION = 3 THEN CONDITION = 1
        COLOR BLUE, BACKGROUND: PRINT "CONDITION : ";
        IF CONDITION < 0 THEN COLOR GREEN, BACKGROUND: PRINT "DOCKED"
        IF CONDITION = 1 THEN COLOR GREEN, BACKGROUND: PRINT "GREEN "
        IF CONDITION = 2 THEN COLOR ORANGE, BACKGROUND: PRINT "YELLOW"
        IF CONDITION = 3 THEN COLOR FRED, BACKGROUND: PRINT "RED   "
        LOCATE 17, 25
        COLOR BLUE, BACKGROUND: PRINT "CRYSTALS : "; :
        IF CRYSTALS = 1 THEN COLOR GREEN, BACKGROUND: PRINT "STABLE  "
        IF CRYSTALS = 0 THEN COLOR FRED, BACKGROUND: PRINT "UNSTABLE"
        LOCATE 18, 25
        COLOR BLUE, BACKGROUND: PRINT "SHIELD ENERGY : "; : COLOR BLACK, BACKGROUND: PRINT SHENERGY; "    "
        LOCATE 20, 25
        COLOR BLUE, BACKGROUND: PRINT "COMPUTER : ";
        IF computer = 1 THEN COLOR GREEN, BACKGROUND: PRINT "FUNCTIONAL";  ELSE COLOR RED, BACKGROUND: PRINT "DAMAGED   ";
        LOCATE 16, 55
        COLOR BLUE, BACKGROUND: PRINT "PHASORS : ";
        IF PHASORS = 1 THEN COLOR GREEN, BACKGROUND: PRINT "OPERATIONAL" ELSE COLOR FRED, BACKGROUND: PRINT "DAMAGED    "
        LOCATE 17, 55
        COLOR BLUE, BACKGROUND: PRINT "PHOTON "
        LOCATE 18, 55: PRINT "TORPEDOES : ";
        IF TORPEDOES < 0 THEN COLOR FRED, BACKGROUND: PRINT "TUBES DAMAGED";
        IF TORPEDOES = 0 THEN COLOR RED, BACKGROUND: PRINT TORPEDOES; "          ";
        IF TORPEDOES > 0 THEN COLOR BLACK, BACKGROUND: PRINT TORPEDOES; "          ";
        LOCATE 19, 55
        COLOR BLUE, BACKGROUND: PRINT "TRANSPORTER : ";
        IF TRANSPORTER = 1 THEN COLOR GREEN, BACKGROUND: PRINT "OPERATIONAL" ELSE COLOR RED, BACKGROUND: PRINT "DAMAGED   "
        LOCATE 20, 55
        COLOR BLUE, BACKGROUND: PRINT MENEMIES$; "s LEFT : "; KLINGONS + COMMANDERS + SUPERS
        VIEW PRINT 21 TO 24
        IF CRM < 21 THEN CRM = 24: CCM = 1
        LOCATE CRM, CCM
END SUB

SUB REPAIRSTATUS
        '
        '       This routine informs the Captain of device repair status
        '
        SHARED DLEN(), BACKGROUND
        TIMER OFF
        VIEW PRINT 1 TO 24
        CLS
        COLOR RED, BACKGROUND
        PRINT "DEVICE           REPAIR TIMES:     UNDOCKED        DOCKED"
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT USING "WARP DRIVE                         ####.##        ####.##"; DLEN(1); DLEN(1) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "SHIELDS                            ####.##        ####.##"; DLEN(2); DLEN(2) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "PHASORS                            ####.##        ####.##"; DLEN(3); DLEN(3) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "PHOTON TORPEDOE TUBES              ####.##        ####.##"; DLEN(4); DLEN(4) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "CLOAKING DEVICE                    ####.##        ####.##"; DLEN(5); DLEN(5) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "COMPUTER                           ####.##        ####.##"; DLEN(6); DLEN(6) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "LIFE SUPPORT SYSTEMS               ####.##        ####.##"; DLEN(7); DLEN(7) / 20
        COLOR ORANGE, BACKGROUND
        PRINT USING "DILITHIUM CRYSTALS                 ####.##        ####.##"; DLEN(8); DLEN(8) / 20
        PRINT
        COLOR BLUE, BACKGROUND
        PRINT : PRINT "Hit any key to return to game..."
rep:    A$ = INKEY$: IF A$ = "" THEN GOTO rep
        CLS
        LOCATE 24, 1
        CALL MAKEDISPLAY
        TIMER ON
END SUB

SUB SECDRAW STATIC
        '
        ' This subroutine redraws the whole sector
        '
        SHARED SX, SY, EX, EY, STRENGTH(), CONDITION, BACKGROUND, MENEMIES$
        TIMER OFF
        IF EX < 1 THEN EX = 1
        IF EX > 9 THEN EX = 9
        IF EY < 1 THEN EY = 1
        IF EY > 9 THEN EY = 9
        IF SHIP$ = "U.S.S. ENTERPRISE" THEN
                SEC$(EX, EY) = "E"
        ELSE
                SEC$(EX, EY) = "Q"
        END IF
        CRS = CSRLIN
        CCS = POS(0)
        WIDTH 80, 25
        VIEW PRINT 1 TO 24
        COLOR BLUE, BACKGROUND
        LOCATE 1, 52
        PRINT "  Sector"; SX; ","; SY; " Map"
        LOCATE 3, 48
        PRINT "  1  2  3  4  5  6  7  8  9"
        FOR I = 1 TO 9
        COLOR BLUE, BACKGROUND
        LOCATE 3 + I, 46
        PRINT STR$(I); : COLOR BLACK, BACKGROUND
        FOR J = 1 TO 9
        COLOR BLACK, BACKGROUND
        IF SEC$(J, I) = CHR$(15) THEN COLOR ORANGE, BACKGROUND
        IF SEC$(J, I) = CHR$(21) THEN COLOR PURPLE, BACKGROUND
        IF SEC$(J, I) = "K" THEN COLOR ORANGE, BACKGROUND
        IF SEC$(J, I) = "S" THEN COLOR FRED, BACKGROUND
        IF SEC$(J, I) = "C" THEN COLOR RED, BACKGROUND
        IF SEC$(J, I) = "P" THEN COLOR GREEN, BACKGROUND
        IF SEC$(J, I) = "E" THEN COLOR FBLUE, BACKGROUND
        IF SEC$(J, I) = "Q" THEN COLOR FBLUE, BACKGROUND
        IF SEC$(J, I) = "B" THEN COLOR BLUE, BACKGROUND
        IF SEC$(J, I) = "*" THEN COLOR PURPLE, BACKGROUND
        IF SEC$(J, I) = "R" THEN
                IF STRENGTH(J, I) > 1500 THEN
                        PRINT "  .";
                        GOTO SECENDJ
                END IF
                COLOR ORANGE, BACKGROUND
        END IF
        IF MENEMIES$ <> "Klingon" AND SEC$(J, I) = "K" THEN
                PRINT "  "; LEFT$(MENEMIES$, 1);
        ELSE
                PRINT "  "; SEC$(J, I);
        END IF
        COLOR BLACK, BACKGROUND
SECENDJ: NEXT J
        COLOR BLUE, BACKGROUND: PRINT " "; STR$(I)
        NEXT I
        VIEW PRINT 21 TO 24
        IF CRS < 21 THEN CRS = 24: CCS = 1
        LOCATE CRS, CCS
        IF CONDITION >= 0 THEN TIMER ON
END SUB

SUB SENERGY
        '
        ' This subroutine allows one to change the energy of the shields
        '
        SHARED C$, SHIELDS, SHENERGY, ENERGY, BACKGROUND
        IF SHIELDS < 0 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'Shields are damaged, Captain.'"
                EXIT SUB
        END IF
        C$ = RIGHT$(C$, LEN(C$) - 2)
        IF LEN(C$) = 0 THEN
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " asks, 'By how much to we change the shield energy ";
                INPUT SHCHANGE
        ELSE
                SHCHANGE = VAL(C$)
        END IF
        IF SHCHANGE > ENERGY THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " says, 'But Captain, we need a wee bit more energy to do that !'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF SHCHANGE < 0 AND ABS(SHCHANGE) >= SHENERGY THEN
                ENERGY = ENERGY + SHENERGY - 100
                SHENERGY = 0
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'All energy drained from shields.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF SHCHANGE > 10000 - SHENERGY THEN SHCHANGE = 10000 - SHENERGY
        IF SHCHANGE < 0 AND ABS(SHCHANGE) > 20000 - ENERGY THEN SHCHANGE = ENERGY - 20000
        IF SHCHANGE < 0 AND ABS(SHCHANGE) <= SHENERGY THEN
                ENERGY = ENERGY - SHCHANGE - 100
                SHENERGY = SHENERGY + SHCHANGE
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, ' "; ABS(SHCHANGE); " energy units drained from shields.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF SHCHANGE > 0 AND SHCHANGE + 100 <= ENERGY THEN
                ENERGY = ENERGY - SHCHANGE - 100
                SHENERGY = SHENERGY + SHCHANGE
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports,' "; SHCHANGE; " energy units diverted to shields.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF

END SUB

SUB SHIELD
        '
        ' This routine raises or lowerers the shields
        '
        SHARED BACKGROUND
        IF SHIELDS = 1 OR SHIELDS = 0 THEN ENERGY = ENERGY - 100
        IF ENERGY <= 0 THEN ENERGY = 0: COLOR RED, BACKGROUND: PRINT "NO ENERGY": CALL MAKEDISPLAY: EXIT SUB
        IF SHIELDS = 0 THEN SHIELDS = 1: CALL MAKEDISPLAY: EXIT SUB
        IF SHIELDS = 1 THEN SHIELDS = 0: CALL MAKEDISPLAY: EXIT SUB
        IF SHIELDS < 0 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'Shields are damaged, Captain.'"
                EXIT SUB
        END IF
END SUB

SUB SWAIT
        '
        '       This allows the passage of Star Time
        '
        SHARED SDATE, ODATE, BACKGROUND
        COLOR RED, BACKGROUND
        PRINT "How long to wait "; : INPUT W
        IF W <= 0 THEN EXIT SUB
        ODATE = SDATE
        SDATE = SDATE + W
END SUB
