'
'    Module TREKMOD2.BAS
'
'    This version written by Burns Lab, University of Florida
'    Physics Department
'
'    Trek is an enhanced and expanded recreationn from memory of it's function, of Super Star Trek written around
'    1975 in Fortran, I believe by David Matuszek & Paul Reynolds with modifications by Don Smith.
'
'    Three modules must be compiled together in QuickBasic 4.5
'
'    TREK.BAS
'    TREKMOD1.BAS
'    TREKMOD2.BAS
'
'    Start Date: 1988 by Michael Burns
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <https://www.gnu.org/licenses/>.
'
'
'    BETA TEST VERSION 3.0  LAST UPDATE 5-JAN-91
'
'    Copyrigth 1991 by Michael Burns, US copyright registration number TX946379
'
DECLARE SUB TRANSPORT ()
DECLARE SUB SSCAN ()
DECLARE SUB ABANDON ()
DECLARE SUB CHNGCLOAK ()
DECLARE SUB COMMANDS ()
DECLARE SUB COMSCREEN ()
DECLARE SUB DELAY (X!)
DECLARE SUB DOCK ()
DECLARE SUB ENDGAME ()
DECLARE SUB GALDRAW ()
DECLARE SUB HELP ()
DECLARE SUB INITSECT ()
DECLARE SUB KATTACKS ()
DECLARE SUB LRSCAN ()
DECLARE SUB MAKEDISPLAY ()
DECLARE SUB MOVE ()
DECLARE SUB NOVA ()
DECLARE SUB PHASOR ()
DECLARE SUB PTORPEDOES ()
DECLARE SUB REPAIRS ()
DECLARE SUB REPAIRSTATUS ()
DECLARE SUB SECDRAW ()
DECLARE SUB SENERGY ()
DECLARE SUB SETWARP ()
DECLARE SUB SHIELD ()
DECLARE SUB SWAIT ()
DECLARE SUB SRANGESCAN ()
DECLARE SUB WORKSHEET ()
DECLARE SUB TIMEWARP ()
        DIM GAL$(9, 9), HGAL$(9, 9), OGAL$(9, 9), CGAL(9, 9)' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA, OGAL IS THE ORIGINAL
        DIM SEC$(10, 10), SUPI(3), SUPJ(3), BEZI(5), BEZJ(5), BEZA(5)
        DIM PLANI(10), PLANJ(10), PLANC(10), COMI(20), COMJ(20), ROMI(20), ROMJ(20)
        DIM STRENGTH(9, 9), DLEN(8), BSI(5), BSJ(5)
        COMMON SHARED /GALAXY/ GAL$(), HGAL$(), OGAL$(), CGAL(), LEVEL' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA
        COMMON SHARED /SECTOR1/ SEC$(), SUPI(), SUPJ(), BEZI(), BEZJ(), BEZA()
        COMMON SHARED /SECTOR2/ PLANI(), PLANJ(), PLANC(), COMI(), COMJ(), ROMI(), ROMJ()
        COMMON SHARED /SECTOR3/ STRENGTH(), DLEN(), PLANETS, TDOWN, HEREWEARE
        COMMON SHARED /SHIP1/ drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        COMMON SHARED /SHIP2/ SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, ODATE, life
        COMMON SHARED /SHIP3/ TRANSPORTER, SX, SY, SHIP$, CLOAK, computer, EX, EY
        COMMON SHARED /BASEINFO/ BASES, HELPCOUNT
        COMMON SHARED /ENEMIES1/ BERZERKS, KLINGONS, COMMANDERS, SUPERS, ENEMY, KLINGS
        COMMON SHARED /ENEMIES2/ EATEN, ECLOAK, BFLAG, ROMULANS, oromulans
        COMMON SHARED /ENDGAMEINFO1/ OKLINGONS, OCOMMANDERS, OSUPERS, OROLULANS, ENDOFGAME
        COMMON SHARED /ENDGAMEINFO2/ KBERZERKERS, BASEDESTROYED, PLANETSLOST, IDATE
        COMMON SHARED /STRINGS/ C$, BACKGROUND
        COMMON SHARED /colors/ BLUE, RED, green, FRED, fblue, BLACK, PURPLE, ORANGE
        COMMON SHARED /PLAYERS/ DOCTOR$, ENGINEER$, WOFFICER$, COFFICER$, SOFFICER$, NAVIGATOR$, MENEMIES$, benemies$
GETCOM3: COLOR BLUE, BACKGROUND: TIMER ON
        IF KLINGONS < 1 THEN CALL ENDGAME
        X = FRE("")
        COLOR RED, BACKGROUND
        X = POS(0)
        Y = CSRLIN
        LOCATE 25, 1
        PRINT "Press ? <Enter> for command list, Press F1 for help    ";
        LOCATE Y, X
        COLOR BLUE, BACKGROUND
        PRINT "Command ? ";
WCOM3:   A$ = INKEY$: IF A$ = "" THEN GOTO WCOM3
        IF A$ = CHR$(14) THEN CLS : GOTO GETCOM3
        COLOR BLACK, BACKGROUND
        PRINT A$;
        LINE INPUT ""; C$
        C$ = A$ + C$
        CLS
        ODATE = SDATE
        C$ = UCASE$(C$)
        C$ = LTRIM$(C$): C$ = RTRIM$(C$)
        IF C$ = "ABANDON" THEN CALL ABANDON: GOTO GETCOM3
        IF LEFT$(C$, 2) = "CL" THEN CALL CHNGCLOAK: CALL KATTACKS: GOTO UNIVRESPONSE
        IF C$ = "D" OR C$ = "DOCK" THEN CALL DOCK: GOTO UNIVRESPONSE
        IF C$ = "?" THEN CALL COMMANDS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 4) = "HELP" THEN CALL HELP: GOTO UNIVRESPONSE
        IF C$ = "L" OR C$ = "LONG" THEN CALL LRSCAN: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "M " THEN CALL MOVE: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "T " THEN CALL PTORPEDOES: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "TR" THEN CALL TRANSPORT: GOTO UNIVRESPONSE
        IF LEFT$(C$, 1) = "P" THEN CALL PHASOR: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "SE" THEN CALL SENERGY: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "SH" THEN CALL SHIELD: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 2) = "WA" THEN CALL SWAIT: CALL KATTACKS: GOTO UNIVRESPONSE
        IF LEFT$(C$, 1) = "W" THEN CALL SETWARP
        IF LEFT$(C$, 2) = "RS" THEN CALL REPAIRSTATUS
        IF LEFT$(C$, 1) = "F" THEN CALL WORKSHEET
        IF C$ = "S" THEN
                CALL SSCAN
                VIEW PRINT 1 TO 24
                CLS
                CALL MAKEDISPLAY
        END IF
        IF C$ = "QUIT" THEN CALL ENDGAME
        IF ENDOFGAME = 1 THEN
                PRINT "Sorry, memory is fractured. You must restart TREK form DOS."
                END
        END IF
UNIVRESPONSE: CALL REPAIRS
        GOTO GETCOM3
ERROR3: COLOR RED, BACKGROUND
        PRINT "Say what ?"
        COLOR BLUE, BACKGROUND: PRINT : PRINT
        RESUME GETCOM3

SUB COMSCREEN
        '
        '       This routine gives details on how to use the commands.
        '
        SHARED BACKGROUND
        TIMER OFF
        VIEW PRINT 1 TO 24
        CLS
        COLOR RED, BACKGROUND
        PRINT "COMMAND SYNTAX:"
        PRINT
        COLOR BLUE, BACKGROUND
        PRINT "The characters typed in ";
        IF BACKGROUND = 7 THEN
                COLOR RED, BACKGROUND
                PRINT "RED ";
        ELSE
                PRINT "CAPITALS ";
        END IF
        COLOR BLUE, BACKGROUND: PRINT " are those used to execute these commands."
        PRINT
        COLOR RED, BACKGROUND:
        PRINT " ABANDON"; : COLOR BLUE, BACKGROUND: PRINT "          ship is abandoned."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "TO RAISE OR LOWER CLOAKING DEVICE :"
        COLOR RED, BACKGROUND
        PRINT " CL"; : COLOR BLUE, BACKGROUND: PRINT "                     This command changes the Cloaking Device"
        PRINT "                        If up ---> change to down."
        PRINT "                        If down ---> change to up."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "To dock/undock at a Star Base :"
        COLOR RED, BACKGROUND
        PRINT " D"; : COLOR BLUE, BACKGROUND: PRINT "                energy, torpedoes replenished. Repairs can be made."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "To temporarily hide from your co-workers and boss that you are"
        PRINT "diddiling around with this game rather than working:"
        COLOR RED, BACKGROUND
        PRINT " F"; : COLOR BLUE, BACKGROUND: PRINT "                 Flips a fake Lotus 123-looking screen up."
        PRINT "                 Hitting the TAB key brings the game back."
        PRINT "                 Hitting % silently kills the game and "
        PRINT "                 prints a fake error message. Hitting / runs a DOS"
        PRINT "                 shell."
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC1END: A$ = INKEY$: IF A$ = "" THEN GOTO SC1END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "For rescue by a Star Base :"
        COLOR RED, BACKGROUND
        PRINT " HELP"; : COLOR BLUE, BACKGROUND: PRINT "             The nearest Star Base will make"
        PRINT "                  three attempts at using the experimental"
        PRINT "                  galactic transporter beam to transport"
        PRINT "                  the ship to safty."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "To perform a long range scan :"
        COLOR RED, BACKGROUND
        PRINT " L"; : COLOR BLUE, BACKGROUND: PRINT "        long range sensors can detect regular "; MENEMIES$
        PRINT "          and stars in adjacent quadrants. The various cloaking"
        PRINT "          devices of "; MENEMIES$; " Commanders ("; : COLOR RED, BACKGROUND: PRINT "C"; : COLOR BLUE, BACKGROUND: PRINT "), "; MENEMIES$; " Super Commanders ("; : COLOR FRED, BACKGROUND: PRINT "S"; : COLOR BLUE, BACKGROUND: PRINT "),"
        PRINT "          Romulans ("; : COLOR ORANGE, BACKGROUND: PRINT "R"; : COLOR BLUE, BACKGROUND: PRINT ") and the "; benemies$; " machines ("; : COLOR PURPLE, BACKGROUND: PRINT CHR$(21); : COLOR BLUE, BACKGROUND: PRINT ") allow them"
        PRINT "          to escape detection except possibly at close range. "; : COLOR PURPLE, BACKGROUND: PRINT "Romulans"
        PRINT "         can very often escape detection even at short range if they"
        PRINT "         have sufficient energy. In this case, they will appear to be"
        PRINT "         invisible until they are too weak to power their cloaking devices."
        PRINT : COLOR BLUE, BACKGROUND
        PRINT "    The map of the explored galaxy quadrants is read as"
        PRINT "         #Regular "; MENEMIES$; "s, Base, #Stars"
        PRINT
        PRINT "    For example  803 means 8 regular "; MENEMIES$; "s, no Star Bases and 3 stars."
        PRINT "                 2B6 means 2 regular "; MENEMIES$; ", a Star Base and 6 stars."; ""
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC2END: A$ = INKEY$: IF A$ = "" THEN GOTO SC2END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO MOVE SHIP - manually :"
        COLOR RED, BACKGROUND
        PRINT " M M x y "; : COLOR BLUE, BACKGROUND: PRINT "         displaces ship by x & y sectors within the quadrant"
        COLOR RED, BACKGROUND
        PRINT " M M qx qy x y "; : COLOR BLUE, BACKGROUND: PRINT "   displaces ship by qx & qy quadants within the galaxy"
        PRINT "                  and by x & y sectors relative to its current position."
        COLOR ORANGE, BACKGROUND: PRINT "             - automatically :"
        COLOR RED, BACKGROUND
        PRINT " M A x y "; : COLOR BLUE, BACKGROUND: PRINT "         automatically moves ship to sector x,y within the quadrant"
        COLOR RED, BACKGROUND
        PRINT " M A qx qy x y "; : COLOR BLUE, BACKGROUND: PRINT "   automatically moves ship to quadrant qx,qy within the galaxy"
        PRINT "                  and to sector x,y within quadant qx,qy"
        PRINT
        PRINT
        PRINT "             qx,qy,x & y ARE IN THE RANGE OF -9 TO 9"
        PRINT
        COLOR FRED, BACKGROUND: PRINT "          ALL MOVE COMMANDS MUST FOLLOW THE ABOVE SYNTAX"
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC3END: A$ = INKEY$: IF A$ = "" THEN GOTO SC3END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO FIRE PHASORS - automatically :"
        COLOR RED, BACKGROUND
        PRINT " P A n"; : COLOR BLUE, BACKGROUND: PRINT "                  n is the number energy units the fire"
        PRINT "                        control computer is allowed to use. The computer"
        PRINT "                        evaluates each threat in the quadrant and targets "
        PRINT "                        the energy for maximum kills against the largest"
        PRINT "                        threats. If n is omitted, n = 1000 or half of the ships"
        PRINT "                        energy, whichever is less."
        COLOR ORANGE, BACKGROUND
        PRINT "                - manually :"
        COLOR RED, BACKGROUND
        PRINT " P M"; : COLOR BLUE, BACKGROUND: PRINT "                    The fire control computer performs a threat"
        PRINT "                        analysis and asks how much energy you wish to"
        PRINT "                        direct against each target. It will inform you of"
        PRINT "                        its analysis of each target."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "TO QUIT THE GAME :"
        COLOR RED, BACKGROUND
        PRINT " QUIT"; : COLOR BLUE, BACKGROUND: PRINT "                 Ends the game and gives you the score."
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC4END: A$ = INKEY$: IF A$ = "" THEN GOTO SC4END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO FIND THE LENGTHS OF EQUIPMENT REPAIRS :"
        COLOR RED, BACKGROUND
        PRINT " RS"; : COLOR BLUE, BACKGROUND: PRINT "                    produces a listing of all damagable"
        PRINT "                       equipment on board and the in flight repair times"
        PRINT "                       and Star Base docked repair times. Use the"
        PRINT "                       "; : COLOR RED, BACKGROUND: PRINT "W"; : COLOR BLUE, BACKGROUND: PRINT " command to effect repairs"
        PRINT "                       or allow them to be repaired as you travel."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "TO PERFORM A SHORT RANGE SCAN :"
        COLOR RED, BACKGROUND
        PRINT " S    "; : COLOR BLUE, BACKGROUND: PRINT "           This command gives a short-range "
        PRINT "                 scan report about the current sector. Report includes"
        PRINT "                 information about planets and their resources, detectable"
        PRINT "                 enemies, stars and bases. Planets which contain crystals"
        PRINT "                 can be mined and the crystals used to reenergise the ship."
        PRINT "                 Fully cloaked Romulans will not be seen on-screen or by "
        PRINT "                 these sensors."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "TO CHANGE SHIELD ENERGY :"
        COLOR RED, BACKGROUND
        PRINT " SE n"; : COLOR BLUE, BACKGROUND: PRINT "                   n is the number of energy units to raise shields."
        PRINT "                        If n>0 then shield energy is increased (10000 unit max)"
        PRINT "                        If n<0 then shield energy is lowered."
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC5END: A$ = INKEY$: IF A$ = "" THEN GOTO SC5END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO RAISE OR LOWER SHIELDS :"
        COLOR RED, BACKGROUND
        PRINT " SH"; : COLOR BLUE, BACKGROUND: PRINT "                     This command changes the shields"
        PRINT "                        If up ---> change to down."
        PRINT "                        If down ---> change to up."
        PRINT
        COLOR ORANGE, BACKGROUND
        PRINT "TO FIRE PHOTON TORPEDOES (up to 3) :"
        COLOR RED, BACKGROUND
        PRINT " T n x1 y1 x2 y2 x3 y3 "; : COLOR BLUE, BACKGROUND: PRINT " n is the number of torpedoes (1,2 or 3)."
        PRINT "                        xi yi are the target coordinates for each torpedoe."
        PRINT "                        "
        PRINT "                        At least one target coordinate pair must be specified."
        PRINT "                        If more torpedoes than target coordinates are"
        PRINT "                        specified, the ships computer will assume multiple"
        PRINT "                        torpedoes go to the last coordinate pair. "
        PRINT "                        For Example:"
        PRINT "                                 T 3 5 5 will be treated as T 3 5 5 5 5 5 5"
        PRINT "                                 T 3 2 3 1 3 wil be treated as T 3 2 3 1 3 1 3"
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC6END: A$ = INKEY$: IF A$ = "" THEN GOTO SC6END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO TRANSPORT TO AND FROM A PLANET :"
        COLOR RED, BACKGROUND
        PRINT " TR  "; : COLOR BLUE, BACKGROUND: PRINT "            This beams a landing party up or"
        PRINT "                 down from a planet surface. If the planet contains dilithium"
        PRINT "                 crystals, then they will be mined. Shields must be down to"
        PRINT "                 beam up or down and you cannot leave the landing"
        PRINT "                 party stranded."
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC7END: A$ = INKEY$: IF A$ = "" THEN GOTO SC7END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO SET SHIP SPEED :"
        COLOR RED, BACKGROUND
        PRINT " W n"; : COLOR BLUE, BACKGROUND: PRINT "             This command sets the ships speed to warp n."
        PRINT "                 If n is omitted or illegal, you will be prompted."
        PRINT "                 This value can be from warp 0 to warp 10."
        PRINT "                 Running at speeds in excess of warp 8 is dangerous -"
        PRINT "                 the dual warp pods lose coherence causing possible"
        PRINT "                 time warping instead of pure space warping. Above"
        PRINT "                 warp 8 but below warp 9.8, the ship will sometimes"
        PRINT "                 warp correctly and sometimes timewarp. The larger "
        PRINT "                 the warp setting the more likly a time warp will occur."
        PRINT "                 Above warp 9.8 the warp drive is purely time warping."
        PRINT "                 This means you change temporal location but don't move"
        PRINT "                 spacially. "
        COLOR RED, BACKGROUND
        PRINT "                 If you end up having gone backward through time,"
        PRINT "                 you may find the enemies you killed alive again!"
        PRINT "                 Don't bet on timewarping forward to find you enemies"
        PRINT "                 dead of old age. Timewarps also have a nasty habit of"
        PRINT "                 draining the antimatter reactors."
        COLOR BLUE, BACKGROUND
        PRINT "                 Warp settings of less than 1 run the impulse engines."
        PRINT "                 Use this mode ( WARP <= 1 ) when Warp Drive is damaged."
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC8END: A$ = INKEY$: IF A$ = "" THEN GOTO SC8END
        CLS
        COLOR ORANGE, BACKGROUND
        PRINT "TO WAIT WHILE REPAIRS ARE UNDERWAY :"
        COLOR RED, BACKGROUND
        PRINT " WA  "; : COLOR BLUE, BACKGROUND: PRINT "                          Will ask for the number of Star Dates to wait."
        PRINT
        COLOR RED, BACKGROUND: PRINT : PRINT "HIT ANY KEY TO RETURN TO GAME..."
SCEEND: A$ = INKEY$: IF A$ = "" THEN GOTO SCEEND
        CLS
        LOCATE 24, 1
        CALL MAKEDISPLAY
        TIMER ON
END SUB

SUB DELAY (X) STATIC
        '
        '       THIS ROUTINE DELAYS FOR X SECONDS. THE RESOLUTION
        '       OF THE TIME DELAY IS 0.05 SECONDS. MAXIMUM DELAY WOULD
        '       48 HOURS-0.01 SECONDS, BUT ONLY IF THE DELAY WAS STARTED
        '       AT MIDNIGHT. FOR ARBITRARY STARTING TIME, THE MAX DELAY
        '       IS 24 HOURS.
        '
        TIMER OFF
        DELAYEND = X + TIMER
        IF DELAYEND < 86400 THEN
                ODATE$ = " "
                GOTO DELAYLOOP
        END IF
        ODATE$ = DATE$
        DREMAINDER = DELAYEND - INT(DELAYEND)
        DELAYEND = INT(DELAYEND) / 86400
        DELAYEND = DELAYEND - INT(DELAYEND)
        DELAYEND = DELAYEND * 86400 + DREMAINDER
DELAYLOOP: IF DELAYEND > TIMER OR ODATE$ = DATE$ THEN GOTO DELAYLOOP
        TIMER ON
END SUB

SUB PTORPEDOES
        '
        ' We now target, fire and track the photon torpedoes
        '
        SHARED SX, SY, SHIP$, EX, EY, BEZI(), BEZJ(), BEZA()
        SHARED ROMULANS, COMMANDERS, SUPERS, BERZERKS, PLANETS, BASES
        SHARED KLINGS, ENEMY, KLINGONS
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
        SHARED TRANSPORTER, C$, computer, BACKGROUND
        DIM SLOPE(3), OX%(3), OY%(3), TRAJECTORY(3), II(3), EXIST(3)
        DIM INDEX(3), INDEY(3), IX(3), IY(3), TX(3), TY(3)
        ON ERROR GOTO ERROR3
        IF TORPEDOES < 0 THEN
                COLOR RED, BACKGROUND
                PRINT "Fire Control reporting, Sir. The Photon Tubes won't fire."
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF TORPEDOES = 0 THEN
                COLOR RED, BACKGROUND
                PRINT "Fire Control reporting, Sir. No Photons left down here."
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF computer = 0 THEN
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, 'The Photon tubes cannot be aimed with a damaged computer.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        FOR I = 1 TO 9
                FOR J = 1 TO 9
                        IF SEC$(I, J) = "K" OR SEC$(I, J) = "S" OR SEC$(I, J) = "C" OR SEC$(I, J) = "R" THEN
                                IF STRENGTH(I, J) <= 0 THEN
                                        COLOR RED, BACKGROUND
                                        PRINT WOFFICER$; " reports, 'Enemy ";
                                        PRINT " at "; I; ","; J; " just exploded, Sir.'"
                                                IF WOFFICER$ = "Chekov" THEN PRINT "wessel";  ELSE PRINT "vessel";
                                        COLOR BLUE, BACKGROUND
                                        IF SEC$(I, J) = "R" OR SEC$(I, J) = "." THEN
                                                ROMULANS = ROMULANS - 1
                                                SEC$(I, J) = "."
                                                STRENGTH(I, J) = 1000000!
                                                GOTO FREDJ
                                        END IF
                                        KLINGONS = KLINGONS - 1
                                        ENEMY = ENEMY - 1
                                        STRENGTH(I, J) = 1000000!
                                        IF SEC$(I, J) = "K" THEN
                                                KLINGS = KLINGS - 1
                                                IF KLINGS < 1 THEN KLINGS = 0
                                                HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                                                HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                                                GAL$(SX, SY) = HGAL$(SX, SY)
                                        END IF
                                        SEC$(I, J) = "."
                                        CALL SECDRAW
                                END IF
                        END IF
FREDJ:          NEXT J
        NEXT I

TSTART: FOR J = 1 TO 3
                EXIST(J) = 0
                OX%(J) = 0: OY%(J) = 0
        NEXT J
        I = LEN(C$) - 2
        C$ = RIGHT$(C$, I)
        C$ = LTRIM$(C$)
        NUM = VAL(LEFT$(C$, 2))
        IF NUM > TORPEDOES THEN
                COLOR RED, BACKGROUND
                PRINT "Fire Control reporting, Sir. FIRING ALL REMAINING TORPEDOES."
                COLOR BLUE, BACKGROUND
                NUM = TORPEDOES
        END IF
        ECLOAK = 0
        TORPEDOES = TORPEDOES - NUM
        I = INSTR(C$, " ")
        J = LEN(C$)
        C$ = RIGHT$(C$, J - I)
        C$ = LTRIM$(C$)
        IF LEN(C$) < 3 THEN
                TORPEDOES = TORPEDOES + 1
                COLOR RED, BACKGROUND
                PRINT "Fire Control Reporting, Sir. We did'nt understand that last command."
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF NUM = 3 AND LEN(C$) = 7 THEN C$ = C$ + RIGHT$(C$, 4)
        IF NUM = 3 AND LEN(C$) = 3 THEN C$ = C$ + " " + C$ + " " + C$
        IF NUM = 2 AND LEN(C$) = 3 THEN C$ = C$ + " " + C$
        FOR J = 1 TO NUM
                TX(J) = VAL(LEFT$(C$, 2))
                I = LEN(C$)
                C$ = RIGHT$(C$, I - 2)
                TY(J) = VAL(LEFT$(C$, 2))
                IF RND < .1 THEN
                        IF RND > .5 THEN TX(J) = TX(J) + 1
                        IF RND > .5 THEN TX(J) = TX(J) - 1
                        IF RND > .5 THEN TY(J) = TY(J) + 1
                        IF RND > .5 THEN TY(J) = TY(J) - 1
                        COLOR RED, BACKGROUND
                        PRINT "Fire Control reporting, Sir. WE ARE HAVING AIMING PROBLEMS."
                        COLOR BLUE, BACKGROUND
                        IF TX(J) > 9 THEN TX(J) = 9
                        IF TX(J) < 1 THEN TX(J) = 1
                        IF TY(J) > 9 THEN TY(J) = 9
                        IF TX(J) < 1 THEN TX(J) = 1
                END IF
                IF J < NUM THEN C$ = RIGHT$(C$, LEN(C$) - 2)
                INDEX(J) = 1: IF TX(J) < EX THEN INDEX(J) = -1
                INDEY(J) = 1: IF TY(J) < EY THEN INDEY(J) = -1
                IX(J) = TX(J) - EX: IY(J) = TY(J) - EY
                IF IX(J) <> 0 THEN SLOPE(J) = IY(J) / IX(J)
                OX%(J) = EX: OY%(J) = EY
                EXIST(J) = 1: II(J) = EX
                TRAJECTORY(J) = EY
        NEXT J
TRAG:   FOR J = 1 TO NUM
                IF EXIST(J) = 0 THEN GOTO ENDTII
                        II(J) = II(J) + INDEX(J)
                        IF IX(J) <> 0 THEN TRAJECTORY(J) = CINT((SLOPE(J) * (II(J) - EX)) + EY)
                        IF IX(J) = 0 THEN II(J) = EX: TRAJECTORY(J) = TRAJECTORY(J) + INDEY(J)
                        IF II(J) < 1 OR II(J) > 9 THEN COLOR RED, BACKGROUND: PRINT "MISSED ": COLOR BLUE, BACKGROUND: SEC$(OX%(J), OY%(J)) = ".": EXIST(J) = 0: GOTO REALENDJ
                        IF TRAJECTORY(J) < 1 OR TRAJECTORY(J) > 9 THEN COLOR RED, BACKGROUND: PRINT "MISSED ": COLOR BLUE, BACKGROUND: SEC$(OX%(J), OY%(J)) = ".": EXIST(J) = 0: GOTO REALENDJ
                        IF SEC$(II(J), TRAJECTORY(J)) <> "*" AND SEC$(II(J), TRAJECTORY(J)) <> "." AND (SEC$(II(J), TRAJECTORY(J)) <> "Q" AND SEC$(II(J), TRAJECTORY(J)) <> "E") THEN SEC$(OX%(J), OY%(J)) = ".": EXIST(J) = 0: GOTO TCOLLISION
                        SEC$(OX%(J), OY%(J)) = ".": SEC$(II(J), TRAJECTORY(J)) = "*"
                        OX%(J) = II(J): OY%(J) = TRAJECTORY(J)
ENDTII: NEXT J
        CALL SECDRAW
        GOTO REALENDJ
TCOLLISION: COLOR RED, BACKGROUND: ARMOR = 0: EXIST(J) = 0
        IF SEC$(II(J), TRAJECTORY(J)) = "K" THEN PRINT MENEMIES$; " "; : ARMOR = 1
        IF SEC$(II(J), TRAJECTORY(J)) = "C" THEN
                PRINT MENEMIES$; " Commander "; : ARMOR = 2
                FOR SI = 1 TO 20
                IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                NEXT SI
        END IF
        IF SEC$(II(J), TRAJECTORY(J)) = "P" THEN
                PRINT "Planet ";
                PLANETSLOST = PLANETSLOST + 1
                FOR SI = 1 TO 10
                IF PLANI(SI) = SX AND PLANJ(SI) = SY THEN PLANI(SI) = 0: PLANJ(SI) = 0: SI = 4
                NEXT SI
        END IF
        IF SEC$(II(J), TRAJECTORY(J)) = "B" THEN
                PRINT "Star Base  "; : ARMOR = 0
                BASEDESTROYED = BASEDESTROYED + 1
                BASES = BASES - 1
                HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
                HGAL$(SX, SY) = LEFT$(HGAL$(SX, SY), 1) + "0" + RIGHT$(HGAL$(SX, SY), 1)
                HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
                GAL$(SX, SY) = HGAL$(SX, SY)
        END IF
        IF SEC$(II(J), TRAJECTORY(J)) = "R" THEN
                PRINT "Romulan "; : ARMOR = 2
                FOR SI = 1 TO 20
                IF ROMI(SI) = SX AND ROMJ(SI) = SY THEN ROMI(SI) = 0: ROMJ(SI) = 0: SI = 4
                NEXT SI
        END IF

        IF SEC$(II(J), TRAJECTORY(J)) = "S" THEN
                PRINT "Super Commander "; : ARMOR = 5
                FOR SI = 1 TO 3
                IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                NEXT SI
        END IF
        IF SEC$(II(J), TRAJECTORY(J)) = CHR$(21) THEN
                ARMOR = 1000
                STRENGTH(II(J), TRAJECTORY(J)) = 10000
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " reports, 'Captain, the "; benemies$; "'s hull is solid neutronium."
                PRINT "We don't appear to have damaged it, we only seem to annoy it.'"
                FOR LLI = 1 TO BERZERKS
                        IF BEZI(LLI) = SX AND BEZJ(LLI) = SY THEN BEZA(LLI) = 1
                NEXT LLI
                X = TIMER + 5
BTIMER:         IF TIMER < X THEN GOTO BTIMER
                PRINT benemies$; " ";
        END IF
        IF SEC$(II(J), TRAJECTORY(J)) = " " THEN PRINT "Black Hole "; : GOTO NOVA
        IF SEC$(II(J), TRAJECTORY(J)) = CHR$(15) THEN PRINT "Star "; : GOTO NOVA
        PRINT "at "; STR$(II(J)); ","; STR$(TRAJECTORY(J));
ENDTJ:  SEC$(OX%(J), OY%(J)) = "."
        IF 5300 * RND > ARMOR * STRENGTH(II(J), TRAJECTORY(J)) OR STRENGTH(II(J), TRAJECTORY(J)) <= 0 THEN
                PRINT " Destroyed.": ENEMY = ENEMY - 1
                IF SEC$(II(J), TRAJECTORY(J)) = "K" OR SEC$(II(J), TRAJECTORY(J)) = "C" OR SEC$(II(J), TRAJECTORY(J)) = "S" THEN KLINGS = KLINGS - 1
                IF SEC$(II(J), TRAJECTORY(J)) = "K" THEN
                        HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                        HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                        GAL$(SX, SY) = HGAL$(SX, SY)
                        KLINGONS = KLINGONS - 1
                END IF
                IF SEC$(II(J), TRAJECTORY(J)) = "C" THEN COMMANDERS = COMMANDERS - 1
                IF SEC$(II(J), TRAJECTORY(J)) = "S" THEN SUPERS = SUPERS - 1
                IF SEC$(II(J), TRAJECTORY(J)) = "R" THEN ROMULANS = ROMULANS - 1
                SEC$(II(J), TRAJECTORY(J)) = "."
                STRENGTH(II(J), TRAJECTORY(J)) = 1000000!
                GOTO REALENDJ
        END IF
        IF 5300 * RND > ARMOR * STRENGTH(II(J), TRAJECTORY(J)) THEN
                PRINT " Damaged."
                STRENGTH(II(J), TRAJECTORY(J)) = STRENGTH(II(J), TRAJECTORY(J)) - 1500
                GOTO REALENDJ
        END IF
        STRENGTH(II(J), TRAJECTORY(J)) = STRENGTH(II(J), TRAJECTORY(J)) - 1000
        PRINT " Hit."
REALENDJ: CALL SECDRAW
        IF EXIST(1) > 0 OR EXIST(2) > 0 OR EXIST(3) > 0 THEN GOTO TRAG
        SEC$(OX%(1), OY%(1)) = ".": SEC$(OX%(2), OY%(2)) = ".": SEC$(OX%(3), OY%(3)) = "."
        IF ENEMY < 1 THEN CONDITION = 1
        CALL MAKEDISPLAY
        PRINT ""
        PRINT ""
        PRINT ""
        PRINT ""
        EXIT SUB
NOVA:   PRINT "at "; STR$(II(J)); ","; STR$(TRAJECTORY(J));
        IF RND > .5 THEN
                PRINT " absorbed torpedo."
                GOTO REALENDJ
        END IF
        PRINT " triggered into a nova.": SEC$(II(J), TRAJECTORY(J)) = "."
        STARS = VAL(RIGHT$(HGAL$(SX, SY), 1)) - 1: IF STARS < 1 THEN STARS = 0
        HGAL$(SX, SY) = LEFT$(HGAL$(SX, SY), 2) + LTRIM$(STR$(STARS))
        GAL$(SX, SY) = HGAL$(SX, SY)
        FOR NI = II(J) - 1 TO II(J) + 1
                FOR NJ = TRAJECTORY(J) - 1 TO TRAJECTORY(J) + 1
                        IF NI < 1 OR NI > 9 THEN GOTO ENDNJ
                        IF NJ < 1 OR NJ > 9 THEN GOTO ENDNJ
                        IF NI = EX AND NJ = EY THEN GOTO THROWENT
                        STRENGTH(NI, NJ) = 1000000!
                        IF SEC$(NI, NJ) = "." THEN GOTO ENDNJ
                        IF SEC$(NI, NJ) = "P" THEN
                                PRINT "Planet at "; NI; ","; NJ; " destroyed."
                                PLANETSLOST = PLANETSLOST + 1
                                FOR SI = 1 TO 10
                                IF PLANI(SI) = SX AND PLANJ(SI) = SY THEN PLANI(SI) = 0: PLANJ(SI) = 0: SI = 4
                                NEXT SI
                        END IF
                        IF SEC$(NI, NJ) = "S" THEN
                                PRINT "Super Commander at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = ".": SUPERS = SUPERS - 1
                                FOR SI = 1 TO 3
                                        IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                                NEXT SI
                        END IF
                        IF SEC$(NI, NJ) = "C" THEN
                                PRINT "Commander at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = ".": COMMANDERS = COMMANDERS - 1
                                FOR SI = 1 TO 20
                                        IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                                NEXT SI
                        END IF
                        IF SEC$(NI, NJ) = "R" THEN
                                PRINT "Romulan at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = "."
                                FOR SI = 1 TO 20
                                IF ROMI(SI) = SX AND ROMJ(SI) = SY THEN ROMI(SI) = 0: ROMJ(SI) = 0: SI = 4
                                NEXT SI
                        END IF
                        IF SEC$(NI, NJ) = "B" THEN
                                SEC$(NI, NJ) = "."
                                PRINT "Star Base at "; NI; ","; NJ; "destroyed."
                                BASEDESTROYED = BASEDESTROYED + 1
                                BASES = BASES - 1
                                HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
                                HGAL$(SX, SY) = LEFT$(HGAL$(SX, SY), 1) + "0" + RIGHT$(HGAL$(SX, SY), 1)
                                HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
                                GAL$(SX, SY) = HGAL$(SX, SY)
                        END IF
                        IF SEC$(NI, NJ) = "K" THEN
                                PRINT MENEMIES$; " at "; NI; ","; NJ; "destroyed."
                                ENEMY = ENEMY - 1: SEC$(NI, NJ) = "."
                                KLINGONS = KLINGONS - 1: KLINGS = KLINGS - 1
                                HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                                HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                                GAL$(SX, SY) = HGAL$(SX, SY)
                        END IF
                        IF SEC$(NI, NJ) = CHR$(21) AND RND > .5 THEN
                                PRINT "Berserker at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = "."
                                FOR SI = 1 TO 3
                                IF BEZI(SI) = SX AND BEZJ(SI) = SY THEN BEZI(SI) = 0: BEZJ(SI) = 0: BEZA(SI) = 0: SI = 4
                                KBERZERKERS = KBERZERKERS + 1
                                NEXT SI
                        END IF
                        GOTO ENDNJ
THROWENT:               BEEP: IF RND > .95 * SHIELDS THEN CALL ENDGAME: EXIT SUB
                        SEC$(EX, EY) = "."
NovaLOC:                EX = INT(8 * RND + 1): EY = INT(RND * 8 + 1)
                        IF SEC$(EX, EY) <> "." THEN GOTO NovaLOC
                        DIST = SQR((EX - JJ) ^ 2 + (EY - TRAJECTORYJ) ^ 2) / 10
                        ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
                        ENERGY = ENERGY - ELOSS
                        IF ENERGY < 0 THEN ENERGY = 0
                        SDATE = SDATE + DIST / (SPEED * SPEED)
                        PRINT SHIP$; " thrown by force of nova blast to "; EX; ","; EY; "."
                        IF 2 * RND * SPEED > SPEED * SHIELDS THEN
                                PRINT "Computer Damaged ";
                                DLEN(6) = RND * SPEED
                                computer = 0
                        END IF
                        IF 2 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
                                PRINT "All Weapons Damaged ";
                                DLEN(4) = RND * SPEED
                                DLEN(3) = DLEN(4) * RND
                                TORPEDOES = -1 * ABS(TORPEDOES)
                                PHASORS = 0
                        END IF
                        IF 2 * RND * SPEED > SPEED * (.5 + SHIELDS) THEN
                                PRINT "Shields Damaged ";
                                DLEN(2) = RND * SPEED
                                SHIELDS = -1 * ABS(SHIELDS)
                        END IF
                        IF .5 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
                                PRINT "Life support damaged ";
                                DLEN(7) = RND * SPEED
                                life = 0
                        END IF
                        IF .1 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
                                PRINT "Crystals deterioriating ";
                                DLEN(8) = 20 * (1 - RND) / SPEED
                                CRYSTALS = 0
                        END IF
                        IF KLINGS <> 0 THEN CONDITION = 3
                        CALL MAKEDISPLAY
ENDNJ:          NEXT NJ
ENDNI:  NEXT NI
        GOTO REALENDJ
END SUB

SUB TIMEWARP
        '
        ' HERE WE MOVE THE SHIP THROUGH A TIME-WARP AFTER IT FELL
        ' DOWN A BLACK HOLE OR FROM A WARP ENGINE MALFUNCTION
        '
        SHARED SX, SY, SHIP$, EX, EY, GAL$(), HGAL$(), OGAL$(), CGAL()
        SHARED ROMULANS, COMMANDERS, SUPERS, BERZERKS, PLANETS, BASES
        SHARED KLINGS, KLINGONS
        SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
        SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life, ODATE
        SHARED TRANSPORTER, C$, computer, IDATE, BACKGROUND
        PRINT SOFFICER$; " reports, 'We seem to be in a time-warp, Captain.'"
        NDATE = 1.5 * RND * (SDATE - IDATE)
        IF RND > .5 THEN
                NDATE = SDATE - NDATE
                ELSE
                NDATE = SDATE + NDATE
        END IF
        IF NDATE < SDATE THEN
                PRINT SOFFICER$; " reports, 'Our Stellar Chronometer is running backwards !'"
                FOR I = 1 TO 9
                        FOR J = 1 TO 9
                                IF CGAL(I, J) > NDATE THEN
                                        CKLINGONS = VAL(LEFT$(GAL$(I, J), 1))
                                        OKLINGONS = VAL(LEFT$(OGAL$(I, J), 1))
                                        KLINGONS = KLINGONS + OKLINGONS - CKLINGONS
                                        HGAL$(I, J) = OGAL$(I, J)
                                        GAL$(I, J) = HGAL$(I, J)
                                        CGAL(I, J) = NDATE
                                END IF
                        NEXT J
                NEXT I
        END IF
        IF NDATE > SDATE THEN
                PRINT SOFFICER$; " reports, 'Our Stellar Chronometer is running foward at an incredible rate !'"
        END IF
        CALL DELAY(10)
        PRINT NAVIGATOR$; " says, 'We seemed to have stopped at Stardate "; NDATE; ".'"
        PRINT "'We went into the timewarp at Stardate "; SDATE; ".'"
        SDATE = NDATE
        ODATE = SDATE
        CALL MAKEDISPLAY
END SUB

SUB TRANSPORT
        '
        '       This subroutine transports the crew to a planet suface
        '       and mines dilithium crystals if present.
        '
        SHARED ENERGY, TORPEDOES, SHENERGY, EX, EY, SEC$(), SHIP$, SHIELDS, SX, SY
        SHARED PLANETS, TRANSPORTER, TDOWN, SDATE, HEREWEARE, PLANI(), PLANJ(), PLANC()
        SHARED BACKGROUND
        X = 0
        FOR I = EX - 1 TO EX + 1
                FOR J = EY - 1 TO EY + 1
                        IF J < 1 OR J > 9 THEN GOTO TDENDJ
                        IF I < 1 OR I > 9 THEN GOTO TDENDI
                        X = X + INSTR(SEC$(I, J), "P")
TDENDJ:          NEXT J
TDENDI:  NEXT I
        IF X = 0 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'We are not orbiting a planet, Captian.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF TRANSPORTER <> 1 THEN
                COLOR RED, BACKGROUND
                PRINT ENGINEER$; " reports, 'The transporter is broken, Captian.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF SHIELDS = 1 THEN
                COLOR RED, BACKGROUND
                PRINT NAVIGATOR$; " reports, 'We cannot transport you with raised shields, Captian.'"
                COLOR BLUE, BACKGROUND
                EXIT SUB
        END IF
        IF TDOWN = 0 THEN
                COLOR RED, BACKGROUND
                PRINT "TRANSPORTING DOWN..."
                COLOR BLUE, BACKGROUND
                TDOWN = 1
                FOR TI = 1 TO PLANETS
                        IF PLANI(TI) = SX AND PLANJ(TI) = SY THEN
                                IF PLANC(TI) >= 1 THEN
                                        HEREWEARE = 1
                                        COLOR RED, BACKGROUND
                                        PRINT SOFFICER$; " reports, 'Crystals are all over the ground. We will collect some.'"
                                        COLOR BLUE, BACKGROUND
                                        PLANC(TI) = PLANC(TI) - 1
                                        EXIT SUB
                                END IF
                                IF PLANC(TI) <= 0 THEN
                                        HEREWEARE = 0
                                        COLOR RED, BACKGROUND
                                        X = RND
                                        IF X > 2 / 3 THEN PRINT NAVIGATOR$; " reports, 'There is nothing but barren wasteland. Similar to New Jersey.'"
                                        IF X <= 2 / 3 AND X > 1 / 3 THEN
                                                IF WOFFICER$ = "Chekov" THEN
                                                        PRINT "Chekov reports, 'Is fifteen below zero and raining acid.'"
                                                        PRINT "         'Is much like Siberian beach resort, Captian.'"
                                                END IF
                                                IF WOFFICER$ <> "Chekov" THEN
                                                        PRINT WOFFICER$; " reports, 'Nothing here, Captain.'"
                                                END IF
                                        END IF
                                        IF X <= 1 / 3 THEN
                                                PRINT SOFFICER$; " reports, 'There is nothing of interest here. There is only copious"
                                                PRINT "         quantities of nude humanoid females with large mammaries."
                                                PRINT "         They are quite friendly. They seem to be interested my undergarments.'"
                                        END IF
                                        PLANC(TI) = 0
                                        COLOR BLUE, BACKGROUND
                                        EXIT SUB
                                END IF
                        END IF
                NEXT TI
                EXIT SUB
        END IF
        IF TDOWN = 1 THEN
                COLOR RED, BACKGROUND
                PRINT "TRANSPORTING UP..."
                TDOWN = 0
                COLOR BLUE, BACKGROUND
                IF HEREWEARE = 1 THEN
                        COLOR RED, BACKGROUND
                        IF SHIP$ = "U.S.S. ENTERPRISE" THEN
                                IF ENERGY > 40000 OR TORPEDOES > 40 THEN
                                        PRINT ENGINEER$; " reports, 'Installing these crystals will destroy the ship!'"
                                        COLOR BLUE, BACKGROUND
                                        GOTO DOTRDATE
                                END IF
                        ELSE
                                IF ENERGY > 20000 OR TORPEDOES > 20 THEN
                                        PRINT ENGINEER$; " reports, 'Installing these crystals will destroy the ship!'"
                                        COLOR BLUE, BACKGROUND
                                        GOTO DOTRDATE
                                END IF
                        END IF
                        PRINT ENGINEER$; " reports, 'Crystals installed and adding to ship reserves.'"
                        COLOR BLUE, BACKGROUND
                        IF SHIP$ = "U.S.S. ENTERPRISE" THEN
                                ENERGY = 20000 + ENERGY
                                TORPEDOES = 20 + TORPEDOES
                                SHENERGY = 10000
                        ELSE
                                ENERGY = 10000 + ENERGY
                                TORPEDOES = 10 + TORPEDOES
                                SHENERGY = 5000
                        END IF
DOTRDATE:               SDATE = SDATE + RND
                        HEREWEARE = 0
                        CALL MAKEDISPLAY
                END IF
        END IF
END SUB
